Package: mosbi
Title: Molecular Signature identification using Biclustering
Version: 1.16.0
Authors@R: c(
  person("Tim Daniel", "Rose", email="tim.rose@wzw.tum.de", 
  role = c("cre", "aut")),
  person("Josch Konstantin", "Pauling", 
  email="josch.pauling@tum.de", role = c("aut")),
  person("Nikolai", "Koehler", 
  email="nikolai.koehler@tum.de", role = c("aut")))
Description: This package is a implementation of biclustering ensemble 
  method MoSBi (Molecular signature Identification from Biclustering).
  MoSBi provides standardized interfaces for biclustering results and 
  can combine their 
  results with a multi-algorithm ensemble approach to compute robust 
  ensemble biclusters on molecular omics data.
  This is done by computing similarity networks of biclusters and 
  filtering for overlaps using a custom error model.
  After that, the louvain modularity it used to extract bicluster 
  communities from the similarity network, which can then be converted 
  to ensemble biclusters.
  Additionally, MoSBi includes several network visualization methods 
  to give an intuitive and scalable overview of the results.
  MoSBi comes with several biclustering algorithms, but can be easily 
  extended to new biclustering algorithms.
License: AGPL-3 + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.1.1
Depends: R (>= 4.1)
SystemRequirements: C++17, GNU make
LinkingTo: Rcpp, BH, RcppParallel
Imports: Rcpp, BH, xml2, methods, igraph, fabia, RcppParallel, biclust,
        isa2, QUBIC, akmbiclust, RColorBrewer
Suggests: knitr, rmarkdown, BiocGenerics, runibic, BiocStyle, testthat
        (>= 3.0.0)
Collate: 'RcppExports.R' 'bicluster.R' 'bicluster_net_methods.R'
        'ensemble_bicluster.R' 'extract_BicARE.R'
        'extract_akmbiclust.R' 'extract_biclust.R'
        'extract_biclustpy.R' 'extract_fabia.R' 'extract_isa.R'
        'feature_louvain_overlap.R' 'filter_biclusters.R'
        'get_biclusters.R' 'misc.R' 'mosbi-package.R' 'mouse_data.R'
        'pipeline.R' 'run_algorithms.R'
VignetteBuilder: knitr
biocViews: Software, StatisticalMethod, Clustering, Network
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/mosbi
git_branch: RELEASE_3_22
git_last_commit: 798cd83
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: yes
Packaged: 2025-10-30 05:13:40 UTC; biocbuild
Author: Tim Daniel Rose [cre, aut],
  Josch Konstantin Pauling [aut],
  Nikolai Koehler [aut]
Maintainer: Tim Daniel Rose <tim.rose@wzw.tum.de>

# MoSBi - Molecular signatures using Biclustering

R package of the biclustering ensemble algorithm MoSBi.


For information about the algorithm please have a look at the publication:

>MoSBi: Automated signature mining for molecular stratification and subtyping
>
>Tim Daniel Rose, Thibault Bechtler, Octavia-Andreea Ciora, Kim Anh Lilian Le, Florian Molnar, Nikolai Koehler, Jan Baumbach, Richard Röttger, Josch Konstantin Pauling
>
>Proceedings of the National Academy of Sciences, 2022; 119 (16): e2118210119; 


doi: [https://doi.org/10.1073/pnas.2118210119](https://doi.org/10.1073/pnas.2118210119)

### Installation

The easiest way to install MoSBi is from Bioconductor.

You can find the package [here](https://bioconductor.org/packages/mosbi/) and install is with this command:

``` r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("mosbi")
```

For experienced users, the package can be installed directly from GitHub:

``` r
# install.packages("devtools")
devtools::install_github("tdrose/mosbi")
```


### License

This software is published under the AGPLv3 license.

![AGPLv3 logo](https://www.gnu.org/graphics/agplv3-with-text-162x68.png)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)

## ----setup, message=FALSE-----------------------------------------------------
library(mosbi)

## -----------------------------------------------------------------------------
z_score <- function(x, margin = 2) {
    z_fun <- function(y) {
        (y - mean(y, na.rm = TRUE)) / sd(y, na.rm = TRUE)
    }

    if (margin == 2) {
        return(apply(x, margin, z_fun))
    } else if (margin == 1) {
        return(t(apply(x, margin, z_fun)))
    }
}

bicluster_histo <- function(biclusters) {
    cols <- mosbi::colhistogram(biclusters)
    rows <- mosbi::rowhistogram(biclusters)

    graphics::par(mfrow = c(1, 2))
    hist(cols, main = "Column size ditribution")
    hist(rows, main = "Row size ditribution")
}

## ----message=FALSE------------------------------------------------------------
# get data
data(mouse_data)

mouse_data <- mouse_data[c(
    grep(
        "metabolite_identification",
        colnames(mouse_data)
    ),
    grep("^X", colnames(mouse_data))
)]

# Make data matrix
data_matrix <- z_score(log2(as.matrix(mouse_data[2:ncol(mouse_data)])), 1)

rownames(data_matrix) <- mouse_data$metabolite_identification

stats::heatmap(data_matrix)

## ----message=FALSE------------------------------------------------------------
# Fabia
fb <- mosbi::run_fabia(data_matrix) # In case the algorithms throws an error,
# return an empty list

# isa2
BCisa <- mosbi::run_isa(data_matrix)

# Plaid
BCplaid <- mosbi::run_plaid(data_matrix)

# QUBIC
BCqubic <- mosbi::run_qubic(data_matrix)

# Merge results of all algorithms
all_bics <- c(fb, BCisa, BCplaid, BCqubic)

bicluster_histo(all_bics)

## -----------------------------------------------------------------------------
bic_net <- mosbi::bicluster_network(all_bics, # List of biclusters
    data_matrix, # Data matrix
    n_randomizations = 5,
    # Number of randomizations for the
    # error model
    MARGIN = "both",
    # Use datapoints for metric evaluation
    metric = 4, # Fowlkes–Mallows index
    # For information about the metrics,
    # visit the "Similarity metrics
    # evaluation" vignette
    n_steps = 1000,
    # At how many steps should
    # the cut-of is evaluated
    plot_edge_dist = TRUE
    # Plot the evaluation of cut-off estimation
)

## -----------------------------------------------------------------------------
stats::heatmap(get_adjacency(bic_net))

## -----------------------------------------------------------------------------
plot(bic_net)

## -----------------------------------------------------------------------------
mosbi::plot_algo_network(bic_net, all_bics, vertex.label = NA)

## -----------------------------------------------------------------------------
# Prepare groups for plotting
weeks <- vapply(
    strsplit(colnames(data_matrix), "\\."),
    function(x) {
        return(x[1])
    }, ""
)

names(weeks) <- colnames(data_matrix)

print(sort(unique(weeks))) # 5 colors required

week_cols <- c("yellow", "orange", "red", "green", "brown")

# Plot network colored by week
mosbi::plot_piechart_bicluster_network(bic_net, all_bics, weeks,
    week_cols,
    vertex.label = NA
)
graphics::legend("topright",
    legend = sort(unique(weeks)),
    fill = week_cols, title = "Week"
)

## -----------------------------------------------------------------------------
# Prepare groups for plotting
samples <- vapply(
    strsplit(colnames(data_matrix), "\\."),
    function(x) {
        return(x[2])
    }, ""
)

names(samples) <- colnames(data_matrix)

samples_cols <- RColorBrewer::brewer.pal(
    n = length(sort(unique(samples))),
    name = "Set3"
)


# Plot network colored by week
mosbi::plot_piechart_bicluster_network(bic_net, all_bics, samples,
    samples_cols,
    vertex.label = NA
)
graphics::legend("topright",
    legend = sort(unique(samples)),
    fill = samples_cols, title = "Sample"
)

## -----------------------------------------------------------------------------
coms <- mosbi::get_louvain_communities(bic_net,
    min_size = 3,
    bics = all_bics
)
# Only communities with a minimum size of 3 biclusters are saved.

## -----------------------------------------------------------------------------
# Plot all communities
for (i in seq(1, length(coms))) {
    tmp_bics <- mosbi::select_biclusters_from_bicluster_network(
        coms[[i]],
        all_bics
    )

    mosbi::plot_piechart_bicluster_network(coms[[i]], tmp_bics,
        weeks, week_cols,
        main = paste0("Community ", i)
    )
    graphics::legend("topright",
        legend = sort(unique(weeks)),
        fill = week_cols, title = "Week"
    )

    cat("\nCommunity ", i, " conists of results from the
             following algorithms:\n")
    cat(get_bic_net_algorithms(coms[[i]]))
    cat("\n")
}

## -----------------------------------------------------------------------------
ensemble_bicluster_list <- mosbi::ensemble_biclusters(coms, all_bics,
    data_matrix,
    row_threshold = .1,
    col_threshold = .1
)

## -----------------------------------------------------------------------------
sessionInfo()

#' @include bicluster.R
NULL

#' Extract a list of bicluster objects from an biclustpy output file.
#'
#' @param bics A biclust object.
#' @param transposed \code{True}, if the bicluster calculation was performed
#' on a tranposed matrix.
#' @param mat Original matrix, that was used for biclustering.
#' @param filterfun A function to filter biclusters. Only if the
#' function returns \code{True}, the bicluster is added to the returned list.
#' The function has to accept a the bicluster (given as submatrix
#' of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.
#' @param ... Other parameters forwarded to the \code{filterfun}.
#' @return A list of \code{\link{bicluster}} objects, which have
#' to be valid (See \code{\link{validate_bicluster}}.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # Not run: getBiclustpyClusters("PathToFileOfBiclustpyResults", m)
#' 
#' @export
getBiclustpyClusters <- function(bics, mat,
                                transposed = FALSE,
                                filterfun = NULL, ...) {
    x <- xml2::read_xml(bics)
    b2 <- xml2::xml_children(x)
    numClus <- length(b2)
    tmp <- bicluster()
    res <- list()
    for (i in seq(1, numClus)) {
        if (length(xml2::as_list(xml2::xml_children(b2[i]))[[1]]) == 0) {
            tmp_r <- as.numeric(c())
        } else {
            tmp_r <- as.numeric(strsplit(xml2::as_list(
                xml2::xml_children(b2[i])
            )[[1]][[1]], " ")[[1]]) + 1
        }
        if (length(xml2::as_list(xml2::xml_children(b2[i]))[[2]]) == 0) {
            tmp_c <- as.numeric(c())
        } else {
            tmp_c <- as.numeric(strsplit(xml2::as_list(
                xml2::xml_children(b2[i])
            )[[2]][[1]], " ")[[1]]) + 1
        }
        # generate bicluster object
        if (transposed) {
            tmp <- bicluster(
                column = tmp_r,
                row = tmp_c, algorithm = "biclustpy")
        } else {
            tmp <- bicluster(
                row = tmp_r,
                column = tmp_c, algorithm = "biclustpy")
        }
        tmp <- set_bicluster_names(tmp, mat)
        # Check if cluster fits the constraints
        if (validate_bicluster(tmp)) {
            if (is.null(filterfun)) {
                res[[length(res) + 1]] <- tmp
            } else {
                if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                    res[[length(res) + 1]] <- tmp}}}}
    return(res)
}

#' @include bicluster.R
NULL

#' Convert a bicluster object to an acutal submatrix of the original matrix.
#' @param m Matrix on which the bicluster was computed
#' @param bic Bicluster object
#' @return A matrix.
#' 
#' @examples
#' bicluster_to_matrix(matrix(seq(1:16), nrow=4), 
#'     bicluster(row=c(1,2), column=c(1,2)))
#' @export
methods::setGeneric("bicluster_to_matrix", function(m, bic) {
    methods::standardGeneric("bicluster_to_matrix")
})

#' Convert a bicluster object to an acutal submatrix of the original matrix.
#' @param m Matrix on which the bicluster was computed
#' @param bic Bicluster object
#' @return A matrix.
#' 
#' #' @examples
#' bicluster_to_matrix(matrix(seq(1:16), nrow=4), 
#'     bicluster(row=c(1,2), column=c(1,2)))
#'     
#' @export
methods::setMethod(
    "bicluster_to_matrix",
    c(m = "matrix", bic = "bicluster"),
    function(m, bic) {
        # if(!validate_bicluster(bic)){
        #  stop("Not a valid bicluster")
        # }
        out <- m[bic@row, bic@column]
        if (is.null(rownames(out))) {
            rownames(out) <- as.character(bic@row)
        }
        if (is.null(colnames(out))) {
            colnames(out) <- as.character(bic@column)
        }
        return(out)
    }
)

#' Get the dimensions of a bicluster.
#'
#' @param x A bicluster object.
#' @return A numeric vector with the lengths of the rows and
#' columns of the bicluster.
#' 
#' @examples
#' dim(bicluster(row=c(1,2), column=c(1,2)))
#' @export
methods::setMethod(
    "dim",
    c(x = "bicluster"),
    function(x) {
        return(c(length(x@row), length(x@column)))
    }
)

#' Add row-/colnames to a bicluster object.
#'
#' @param bic A bicluster object.
#' @param m The matrix, that was used for the
#' biclustering. (Works only if matrix has row-/colnames.)
#' @return The updated bicluster object.
#' 
#' @examples
#' m <- matrix(c(1,2,3,4), nrow=2)
#' rownames(m) <- c("r1", "r2")
#' rownames(m) <- c("c1", "c2")
#' set_bicluster_names(bicluster(row=c(1,2), column=c(1,2)), m)
#' 
#' @export
methods::setGeneric("set_bicluster_names", function(bic, m) {
    methods::standardGeneric("set_names")
})

#' Add row-/colnames to a bicluster object.
#'
#' @param bic A bicluster object.
#' @param m The matrix, that was used for the
#' biclustering. (Works only if matrix has row-/colnames.)
#' @return The updated bicluster object.
#' 
#' #' @examples
#' m <- matrix(c(1,2,3,4), nrow=2)
#' rownames(m) <- c("r1", "r2")
#' rownames(m) <- c("c1", "c2")
#' set_bicluster_names(bicluster(row=c(1,2), column=c(1,2)), m)
#' 
#' @export
methods::setMethod(
    "set_bicluster_names",
    c(bic = "bicluster", m = "matrix"),
    function(bic, m) {
        if (!is.null(rownames(m))) {
            bic@rowname <- rownames(m)[bic@row]
        }
        if (!is.null(colnames(m))) {
            bic@colname <- colnames(m)[bic@column]
        }
        return(bic)
    }
)

#' Plot a heatmap of a bicluster
#'
#' Uses the \code{stats::\link[stats]{heatmap}} function.
#'
#' @param bic A bicluster object.
#' @param m The matrix, that was used for the
#' biclustering. (Works only if matrix has row-/colnames.)
#' @param ... Arguments forwarded to \code{stats::\link[stats]{heatmap}}.
#' @return A plot object
#' 
#' @examples
#' m <- matrix(c(1,2,3,4), nrow=2)
#' rownames(m) <- c("r1", "r2")
#' rownames(m) <- c("c1", "c2")
#' bicluster_heatmap(bicluster(row=c(1,2), column=c(1,2)), m)
#' 
#' @export
methods::setGeneric("bicluster_heatmap", function(bic, m, ...) {
    methods::standardGeneric("bicluster_heatmap")
})

#' Plot a heatmap of a bicluster
#'
#' Uses the \code{stats::\link[stats]{heatmap}} function.
#'
#' @param bic A bicluster object.
#' @param m The matrix, that was used for the
#' biclustering. (Works only if matrix has row-/colnames.)
#' @param ... Arguments forwarded to \code{stats::\link[stats]{heatmap}}.
#' @return A plot object
#' 
#' @examples
#' m <- matrix(c(1,2,3,4), nrow=2)
#' rownames(m) <- c("r1", "r2")
#' rownames(m) <- c("c1", "c2")
#' bicluster_heatmap(bicluster(row=c(1,2), column=c(1,2)), m)
#' 
#' @export
methods::setMethod(
    "bicluster_heatmap",
    c(bic = "bicluster", m = "matrix"),
    function(bic, m, ...) {
        return(stats::heatmap(bicluster_to_matrix(m, bic, ...)))
    }
)

#' Randomize a matrix
#'
#' Randomize a matrix bu shuffling all rows and columns.
#'
#' @param m A matrix.
#' @return A randomized version of the input matrix.
#' 
#' @examples
#' m <- matrix(c(1,2,3,4), nrow=2)
#' randomize_matrix(m)
#' @export
randomize_matrix <- function(m) {
    out <- matrix(sample(m), nrow = nrow(m))
    rownames(out) <- rownames(m)
    colnames(out) <- colnames(m)
    return(out)
}

#' Get Algorithms
#'
#' Get a unique vector of algorithms from a
#' list of \code{\link{bicluster}} objects.
#'
#' @param bics a list of \code{\link{bicluster}} objects.
#' @return A character vector with algorithm names
#' 
#' @examples
#' b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4), algorithm="isa"),
#'     bicluster(row=c(3,4,5,6), column=c(3,4,5,6), algorithm="QUBIC"))
#' @export
get_algorithms <- function(bics) {
    return(unique(vapply(bics, function(x) {
        return(x@algorithm)
    }, "")))
}

#' @include bicluster.R
NULL

NoFabia <- function(bics) {
    return(dim(bics$bic)[1])
}

#' Extract a list of bicluster objects from an fabia biclustering object.
#'
#' @param bics Extracted fabia biclusters.
#' @param transposed \code{True}, if the bicluster calculation was performed
#' on a tranposed matrix.
#' @param mat Original matrix, that was used for biclustering.
#' @param filterfun A function to filter biclusters. Only if the function
#' returns \code{True}, the bicluster is added to the returned list.
#' The function has to accept a the bicluster (given as submatrix
#' of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.
#' @param ... Other parameters forwarded to the \code{filterfun}.
#' @return A list of \code{\link{bicluster}} objects, which have to
#' be valid (See \code{\link{validate_bicluster}}.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # res <- fabia::extractBic(fabia::fabia(m, p=5))
#' # getFabiaClusters(res, m)
#' 
#' 
#' @export
getFabiaClusters <- function(bics, mat, transposed = FALSE,
                            filterfun = NULL, ...) {
    if (!requireNamespace("fabia")) {
        stop("Package fabia not available.
        Please install before using this funcion.")}
    numClus <- NoFabia(bics)
    tmp <- bicluster()
    res <- list()
    rows <- seq(1, dim(mat)[1])
    if (is.null(rownames(mat))) {
        if (!transposed) {
            names(rows) <- paste0("gene", rows)
        } else {
            names(rows) <- paste0("sample", rows)
        }
    } else {names(rows) <- rownames(mat)}
    cols <- seq(1, dim(mat)[2])
    if (is.null(colnames(mat))) {
        if (!transposed) {
            names(cols) <- paste0("sample", cols)
        } else {names(cols) <- paste0("gene", cols)}
    } else {names(cols) <- colnames(mat)}
    for (i in seq(1, numClus)) {
        if (transposed) {
            tmp <- bicluster(
                column = cols[bics$bic[i, ]$bixn],
                row = rows[bics$bic[i, ]$biypn],
                algorithm = "fabia")
        } else {
            tmp <- bicluster(
                row = rows[bics$bic[i, ]$bixn],
                column = cols[bics$bic[i, ]$biypn],
                algorithm = "fabia")}
        tmp <- set_bicluster_names(tmp, mat)
        if (validate_bicluster(tmp)) {
            if (is.null(filterfun)) {
                res[[length(res) + 1]] <- tmp
            } else {
                if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                    res[[length(res) + 1]] <- tmp}}}}
    return(res)}

#' A S4 class to store biclusters.
#'
#' @slot row A vector of row.
#' @slot column A vector of columns.
#' @slot rowname A vector of names for the rows in \code{row}.
#' @slot colname A vector of names for the columns in \code{column}.
#' @slot algorithm Algorithm that predicted this bicluster.
#' 
#' @examples 
#' bicluster(row=c(1,2), column=c(1,2), 
#'     rowname=c("a", "b"), colname=c("e", "f"))
#'     
#' @importFrom methods new
#' @export bicluster
#' @exportClass bicluster
bicluster <- methods::setClass(
    # Class name
    "bicluster",

    # Defining slot type
    representation(
        row = "numeric",
        column = "numeric",
        rowname = "character",
        colname = "character",
        algorithm = "character"
    ),

    # Initializing slots
    prototype = list(
        row = as.numeric(NULL),
        column = as.numeric(NULL),
        rowname = as.character(NULL),
        colname = as.character(NULL),
        algorithm = as.character(NULL)
    )
)


#' A S4 class to store bicluster networks.
#'
#' Object that is returned e.g. be the
#' function \code{\link{bicluster_network}}.
#'
#'
#' @slot adjacency_matrix Adjacency matrix of bicluster similarities.
#' @slot threshold Estimated threshold for the bicluster similarity adjacency
#' matrix. All values lower than that in the matrix should be discarded.
#' (Note that the indicated threshold is not applied
#' to the \code{adjacency_matrix})
#' @slot algorithms List of algorithms that contributed to this bicluster
#' network.
#' 
#' @examples
#' bicluster_net(adjacency_matrix=matrix(seq(1:16), nrow=4),
#'     threshold=4)
#' @importFrom methods new
#' @export bicluster_net
#' @exportClass bicluster_net
bicluster_net <- methods::setClass(
    # Class name
    "bicluster_net",

    # Defining slot type
    representation(
        adjacency_matrix = "matrix",
        threshold = "numeric",
        algorithms = "character"
    ),

    # Initializing slots
    prototype = list(
        adjacency_matrix = matrix(),
        threshold = 0,
        algorithms = character()
    )
)


#' A S4 class to store co-occurence networks.
#'
#' Object that is returned e.g. be the function \code{\link{feature_network}}.
#'
#'
#' @slot adjacency_matrix Adjacency matrix of row- and column-element
#' co-occurences.
#' @slot threshold Estimated threshold for the co-occurence adjacency matrix.
#' All values lower than that in the matrix should be
#' discarded. (Note that the indicated threshold is not
#' applied to the \code{adjacency_matrix})
#' 
#' @examples
#' cooccurrence_net(adjacency_matrix=matrix(seq(1:16), nrow=4),
#'     threshold=4)
#'     
#' @importFrom methods new
#' @export cooccurrence_net
#' @exportClass cooccurrence_net
cooccurrence_net <- methods::setClass(
    # Class name
    "cooccurrence_net",

    # Defining slot type
    representation(
        adjacency_matrix = "matrix",
        threshold = "numeric"
    ),

    # Initializing slots
    prototype = list(
        adjacency_matrix = matrix(),
        threshold = 0
    )
)

#' @include bicluster.R
NULL

is_biclust <- function(method){
    return((method == "biclust") | (method == "biclust-bimax") |
            (method == "biclust-cc") |
            (method == "biclust-plaid") | (method == "biclust-quest") |
            (method == "biclust-qubic") | (method == "biclust-spectral") |
            (method == "biclust-xmotifs") | (method == "biclust-unibic"))
}

extract_bf <- function(bics, mat, method, transposed, filterfun, ...){
    b2 <- getallBFClusters(bics)
    numClus <- NoBFBiclusters(bics)
    tmp <- list()
    for (i in seq(1, numClus)) {
        if (transposed) {
            if (validate_bicluster(transpose_bicluster(b2[[i]]))) {
                if (is.null(filterfun)) {
                    tmp[[length(tmp) + 1]] <- set_bicluster_names(
                        transpose_bicluster(b2[[i]]), mat
                    )
                } else {
                    if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                        tmp[[length(tmp) + 1]] <- set_bicluster_names(
                            transpose_bicluster(b2[[i]]), mat)}}}
        } else {
            if (validate_bicluster(b2[[i]])) {
                if (is.null(filterfun)) {
                    tmp[[length(tmp) + 1]] <- set_bicluster_names(
                        b2[[i]], mat)
                } else {
                    if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                        tmp[[length(tmp) + 1]] <- set_bicluster_names(
                            b2[[i]], mat)}}}}}
    
    return(tmp)
}

#' Extract biclusters from different algorithms/packages
#'
#' Converts biclusters output of different algorithms/packages in to lists
#' of \link{bicluster} objects. Many algoritms can be directly executed using
#' the \code{run_...} methods from this package.
#' This directly returns the converted results. Not all algorithms are shipped
#' with this package, like Bi-Force, which is running in Java as a standalone
#' tool or BicARE,
#' which required an full import using \code{library(BicARE)} in order to run.
#' But their results can be converted using this function.
#' @param bics A resulting object from a biclustering
#' algorithm (extracted biclusters for fabia) or filename for stored
#' biclustering results.
#' @param mat Original matrix, that was used for biclustering.
#' @param method Used biclustering package. One of "biclust"
#'                (can be further specified as "biclust-bimax",
#'                "biclust-cc", "biclust-plaid", "biclust-quest",
#'                "biclust-qubic",
#'                "biclust-spectral", "biclust-xmotifs", "biclust-unibic"),
#'                "BicARE", "isa", "fabia", "biforce", "biclustpy", "qubic2"
#'                or "akmbiclust".
#' @param transposed Indicate, whether a transposed version of the matrix is
#' used for biclustering. The \code{matrix} should not be transposed,
#' when this argument is set to \code{True}.
#' @param filterfun A function to filter biclusters.
#' Only if the function returns \code{True}, the bicluster is added to
#' the returned list. The function has to accept a bicluster
#' (given as submatrix of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.
#' @param ... Other parameters forwarded to the \code{filterfun}.
#' @return A list of \code{\link{bicluster}} objects, which are
#' valid (See \code{\link{validate_bicluster}}).
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # res <- isa2::isa(m)
#' # get_biclusters(res, m, "isa")
#' 
#' @export
get_biclusters <- function(bics, mat, method,
                            transposed = FALSE, filterfun = NULL, ...) {
    if (is_biclust(method)) {
        tmp <- getBiclustClusters(bics, mat = mat, method = method,
            transposed = transposed, filterfun = filterfun, ...)
        return(tmp)
    } else if (method == "BicARE") {
        tmp <- getBicAREbiclusters(bics, mat = mat, transposed = transposed,
            filterfun = filterfun, ...)
        return(tmp)
    } else if (method == "isa") {
        tmp <- getIsaClusters(bics, transposed = transposed, mat = mat,
            filterfun = filterfun, ...)
        return(tmp)
    } else if (method == "fabia") {
        tmp <- getFabiaClusters(bics, transposed = transposed, mat = mat,
            filterfun = filterfun, ...)
        return(tmp)
    } else if (method == "biforce") {
        return(extract_bf(bics, mat, method, transposed, filterfun, ...))
    } else if (method == "biclustpy") {
        tmp <- getBiclustpyClusters(bics,
            transposed = transposed, mat = mat, filterfun = filterfun, ...)
        return(tmp)
    } else if (method == "qubic2") {
        qb2 <- getQUBIC2biclusters(bics, transposed = transposed)
        tmp <- list()
        for (i in seq(1, length(qb2))) {
            if (validate_bicluster(qb2[[i]])) {
                if (is.null(filterfun)) {
                    tmp[[length(tmp) + 1]] <- set_bicluster_names(
                        qb2[[i]], mat)
                } else {
                    if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                        tmp[[length(tmp) + 1]] <- set_bicluster_names(
                            qb2[[i]], mat)}}}}
        return(tmp)
    } else if (method == "akmbiclust") {
        tmp <- getAkmbiclustClusters(bics, transposed = transposed, mat = mat,
            filterfun = filterfun, ...)
        return(tmp)
    } else {
        print("Method not available")
        return(list())}}

#' @include bicluster.R
NULL

#' Extract a list of bicluster objects from an akmbiclust biclustering object.
#'
#' @param bics A result object from akmbiclust.
#' @param transposed \code{True}, if the bicluster calculation was
#' performed on a tranposed matrix.
#' @param mat Original matrix, that was used for biclustering.
#' @param filterfun A function to filter biclusters.
#' Only if the function returns \code{True}, the bicluster is added to the
#' returned list. The function has to accept a the
#' bicluster (given as submatrix
#' of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.
#' @param ... Other parameters forwarded to the \code{filterfun}.
#' @return A list of \code{\link{bicluster}} objects, which have to be
#' valid (See \code{\link{validate_bicluster}}.
#' 
#' @examples
#' # Function called in
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # Not run: run_akmbiclust(m, k=10)
#' 
#' @export
getAkmbiclustClusters <- function(bics, mat,
                                transposed = FALSE,
                                filterfun = NULL, ...) {
    numClus <- max(bics$row_labels)

    tmp <- bicluster()
    res <- list()

    for (i in seq(1, numClus)) {
        if (transposed) {
            tmp <- bicluster(
                column = (seq(1, ncol(mat)))[bics$row_labels == i],
                row = (seq(1, nrow(mat)))[bics$col_labels == i],
                algorithm = "akmbiclust"
            )
        } else {
            tmp <- bicluster(
                row = (seq(1, nrow(mat)))[bics$row_labels == i],
                column = (seq(1, ncol(mat)))[bics$col_labels == i],
                algorithm = "akmbiclust"
            )
        }
        tmp <- set_bicluster_names(tmp, mat)
        # Check if cluster fits the constraints
        if (validate_bicluster(tmp)) {
            if (is.null(filterfun)) {
                res[[length(res) + 1]] <- tmp
            } else {
                if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                    res[[length(res) + 1]] <- tmp
                }
            }
        }
    }
    return(res)
}

#' @include bicluster.R
NULL

NoBiclust <- function(bics) {
    return(dim(bics@RowxNumber)[2])
}

#' Extract a list of bicluster objects from a biclust object.
#'
#' @param bics A biclust object.
#' @param transposed \code{True}, if the bicluster calculation was
#' performed on a tranposed matrix.
#' @param mat Original matrix, that was used for biclustering.
#' @param method Name of the used biclustering algorithm. Should be one of
#' the following: "biclust", "biclust-bimax", "biclust-cc", "biclust-plaid",
#' "biclust-quest", "biclust-spectral", "biclust-xmotifs" or "biclust-qubic",
#' "biclust-unibic".
#' @param filterfun A function to filter biclusters. Only if the function
#' returns \code{True}, the bicluster is added to the returned list.
#' The function has to accept a the bicluster (given as submatrix
#' of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.
#' @param ... Other parameters forwarded to the \code{filterfun}.
#' @return A list of \code{\link{bicluster}} objects, which have
#' to be valid (See \code{\link{validate_bicluster}}.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # res <- biclust::biclust(m, method = biclust::BCBimax())
#' # getBiclustClusters(res, m)
#' 
#' @export
getBiclustClusters <- function(bics, mat, method = "biclust",
                            transposed = FALSE,
                            filterfun = NULL, ...) {
    if (!requireNamespace("biclust")) {
        stop("Package biclust not available.
        Please install before using this funcion.")
    }


    numClus <- NoBiclust(bics)

    tmp <- bicluster()
    res <- list()

    # Biclust returns boolean bicluster affiliation
    rows <- seq(1, dim(bics@RowxNumber)[1])
    cols <- seq(dim(bics@NumberxCol)[2])

    for (i in seq(1, numClus)) {

        # generate bicluster object
        if (transposed) {
            tmp <- bicluster(
                column = rows[bics@RowxNumber[, i]],
                row = cols[bics@NumberxCol[i, ]],
                algorithm = method
            )
        } else {
            tmp <- bicluster(
                row = rows[bics@RowxNumber[, i]],
                column = cols[bics@NumberxCol[i, ]],
                algorithm = method
            )
        }
        tmp <- set_bicluster_names(tmp, mat)
        # Check if cluster fits the constraints
        if (validate_bicluster(tmp)) {
            if (is.null(filterfun)) {
                res[[length(res) + 1]] <- tmp
            } else {
                if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                    res[[length(res) + 1]] <- tmp
                }
            }
        }
    }
    return(res)
}

#' Overlap of features/samples in different louvain communities
#' 
#' The function calculates how often features or samples occur across 
#' all calculated louvain communities
#' 
#' @param overlap_tables List of tables as returned by \code{\link{attr_overlap}}.
#' @param mat The data matrix used as input for the biclustering algorithms.
#' 
#' @return List of tables as returned by \code{\link{attr_overlap}}, 
#' extended by a column showing how often elements occur across all tables.
#' 
#' @examples
#' # a = data.frame(type=c("row", "row", "row", "column", "column", "column"), 
#' #   ID=c(1,2,3,1,2,3), Fraction=c(1,1,1,.5, .5, .5))
#' # b = data.frame(type=c("row", "row", "row", "column", "column", "column"), 
#' #   ID=c(3,2,4,1,5,3), Fraction=c(1,1,1,.5, .5, .5))
#' # inl <- list(a, b)
#' # feature_louvain_overlap(outl, matrix(1:100, nrow=10))
#' 
#' @export
feature_louvain_overlap <- function(overlap_tables, mat){
    
    outl <- overlap_tables
    
    # add new column to all tables
    for (i in 1:length(outl)){
        outl[[i]]$overlap <- 0
    }
    
    # Loop over rows
    for (r in 1:nrow(mat)){
        
        counter <- 0
        
        # Loop over tables
        for(j in 1:length(outl)){
            if(length(outl[[j]]$overlap[outl[[j]]$type=="row" & 
                                        outl[[j]]$ID==r]) > 0){
                counter <- counter + 1
            }
        }
        
        if (counter > 0){
            for(j in 1:length(outl)){
                if(length(outl[[j]]$overlap[outl[[j]]$type=="row" & 
                                            outl[[j]]$ID==r]) > 0){
                    outl[[j]]$overlap[outl[[j]]$type=="row" & 
                                          outl[[j]]$ID==r] <- counter
                }
                
            }
        }
    }
    
    # Loop over columns
    for (c in 1:ncol(mat)){
        counter <- 0
        
        # Loop over tables
        for(j in 1:length(outl)){
            if(length(outl[[j]]$overlap[outl[[j]]$type=="column" & 
                                        outl[[j]]$ID==c]) > 0){
                counter <- counter + 1
            }
        }
        
        if (counter > 0){
            for(j in 1:length(outl)){
                if(length(outl[[j]]$overlap[outl[[j]]$type=="column" & 
                                            outl[[j]]$ID==c]) > 0){
                    outl[[j]]$overlap[outl[[j]]$type=="column" & 
                                          outl[[j]]$ID==c] <- counter
                }
                
            }
        }
    }
    
    return(outl)
}

#' @include bicluster.R
NULL


#' Run the fabia biclustering algorithm
#'
#' The function executes the \link[fabia]{fabia} biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param thresZ See parameter from the \link[fabia]{extractBic} function.
#' @param thresL See parameter from the \link[fabia]{extractBic} function.
#' @param ... Other parameters forwarded to the \link[fabia]{fabia} function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(1000), nrow=10)
#' # run_fabia(m, p=5)
#'
#' @export
run_fabia <- function(data_matrix, minRow = 2, minCol = 2, thresZ = 0.5,
                    thresL = NULL, ...) {
    if (!requireNamespace("fabia", quietly = TRUE)) {
        stop("Package \"fabia\" not available. 
        It is reauired for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            fabia::extractBic(
                fabia::fabia(data_matrix, ...),
                thresZ, thresL
            ),
            data_matrix,
            method = "fabia"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("Fabia algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the isa biclustering algorithm
#'
#' The function executes the \link[isa2]{isa} biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to the \link[isa2]{isa} function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # Not run: run_isa(m)
#'
#' @export
run_isa <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("isa2", quietly = TRUE)) {
        stop("Package \"isa2\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(isa2::isa(data_matrix, ...),
            data_matrix,
            method = "isa"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("isa algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the QUBIC biclustering algorithm
#'
#' The function executes the \link[QUBIC]{BCQU} biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to the \link[QUBIC]{BCQU} function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_qubic(m)
#'
#' @export
run_qubic <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("QUBIC", quietly = TRUE)) {
        stop("Package \"QUBIC\" not available. 
        It is required for this function. Please install it."
        )
    }
    if (!requireNamespace("biclust", quietly = TRUE)) {
        stop("Package \"biclust\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            biclust::biclust(data_matrix, method = QUBIC::BCQU(), ...),
            data_matrix,
            method = "biclust-qubic"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("qubic algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the Plaid biclustering algorithm
#'
#' The function executes the \link[biclust]{BCPlaid} biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to the \link[biclust]{BCPlaid}
#' function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_plaid(m)
#'
#' @export
run_plaid <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("biclust", quietly = TRUE)) {
        stop("Package \"biclust\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            biclust::biclust(data_matrix, method = biclust::BCPlaid(), ...),
            data_matrix,
            method = "biclust-plaid"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("Plaid algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the Bimax biclustering algorithm
#'
#' The function executes the \link[biclust]{BCBimax} biclustering algorithm,
#' returning a list of biclusters converted into bicluster
#' objects compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to the \link[biclust]{BCBimax}
#' function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_bimax(m)
#'
#' @export
run_bimax <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("biclust", quietly = TRUE)) {
        stop("Package \"biclust\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            biclust::biclust(data_matrix, method = biclust::BCBimax(), ...),
            data_matrix,
            method = "biclust-bimax"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("Bimax algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the spectral biclustering algorithm
#'
#' The function executes the \link[biclust]{BCSpectral}
#' biclustering algorithm, returning a list of biclusters converted into
#' bicluster objects compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to
#' the \link[biclust]{BCSpectral} function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_spectral(m)
#'
#' @export
run_spectral <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("biclust", quietly = TRUE)) {
        stop("Package \"biclust\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            biclust::biclust(data_matrix, method = biclust::BCSpectral(), ...),
            data_matrix,
            method = "biclust-spectral"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("Spectral algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the Quest biclustering algorithm
#'
#' The function executes the \link[biclust]{BCQuest} biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to the \link[biclust]{BCQuest}
#' function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_quest(m)
#'
#' @export
run_quest <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("biclust", quietly = TRUE)) {
        stop("Package \"biclust\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            biclust::biclust(data_matrix, method = biclust::BCQuest(), ...),
            data_matrix,
            method = "biclust-quest"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("Quest algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the CC biclustering algorithm
#'
#' The function executes the \link[biclust]{BCCC} biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to the \link[biclust]{BCCC} function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_cc(m)
#'
#' @export
run_cc <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("biclust", quietly = TRUE)) {
        stop("Package \"biclust\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            biclust::biclust(data_matrix, method = biclust::BCCC(), ...),
            data_matrix,
            method = "biclust-cc"
        ),
        minRow, minCol
    ),
    error =
        function(e) {
            warning("CC algorithm execution did not succeed.")
            return(list())
        }
    )

    return(out)
}

#' Run the Xmotifs biclustering algorithm
#'
#' The function executes the \link[biclust]{BCXmotifs} biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded to the \link[biclust]{BCXmotifs}
#' function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_xmotifs(m)
#'
#' @export
run_xmotifs <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("biclust", quietly = TRUE)) {
        stop("Package \"biclust\" not available. 
        It is reauired for this function. Please install it.",
            call. = FALSE
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            biclust::biclust(data_matrix, method = biclust::BCXmotifs(), ...),
            data_matrix,
            method = "biclust-xmotifs"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("Xmotifs algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' Run the UniBic biclustering algorithm
#'
#' The function executes the runibic::BCUnibic biclustering algorithm,
#' returning a list of biclusters converted into bicluster objects
#' compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#' 
#'
#' @param data_matrix A numeric matrix.
#' 
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' 
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' 
#' @param ... Other parameters forwarded to the runibic::BCUnibic function.
#' function.
#' 
#' @return a list of \link{bicluster} objects.
#' 
#' @return Function as a string, which can be executed.
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # run_unibic(m, nbic=10)
#'
#' @export
run_unibic <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("runibic", quietly = TRUE)) {
        stop("Package \"runibic\" not available. 
        It is required for this function. Please install it."
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(runibic::BCUnibic(data_matrix, ...),
                        data_matrix,
                        method = "biclust-unibic"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("UniBic algorithm execution did not succeed.")
        return(list())
    }
    )
    
    return(out)}

#' Run the akmbiclust biclustering algorithm
#'
#' The function executes the \link[akmbiclust]{akmbiclust} biclustering
#' algorithm, returning a list of biclusters converted into bicluster
#' objects compatible with this package.
#' If the algorithm fails to run, an empty list is returned.
#'
#' @param data_matrix A numeric matrix.
#' @param minRow Same parameters as in \link{filter_bicluster_size}.
#' @param minCol Same parameters as in \link{filter_bicluster_size}.
#' @param ... Other parameters forwarded
#' to the \link[akmbiclust]{akmbiclust} function.
#' @return a list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # set.seed(10)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # Not run: run_akmbiclust(m, k=10)
#'
#' @export
run_akmbiclust <- function(data_matrix, minRow = 2, minCol = 2, ...) {
    if (!requireNamespace("akmbiclust", quietly = TRUE)) {
        stop("Package \"akmbiclust\" not available. 
        It is required for this function. Please install it.",
            call. = FALSE
        )
    }
    out <- tryCatch(filter_bicluster_size(
        get_biclusters(
            akmbiclust::akmbiclust(data_matrix, ...),
            data_matrix,
            method = "akmbiclust"
        ),
        minRow, minCol
    ),
    error = function(e) {
        warning("akmbiclust algorithm execution did not succeed.")
        return(list())
    }
    )

    return(out)
}

#' @include bicluster.R
NULL

#' Convert communities into ensemble biclusters
#'
#' After calculation of communities with
#' the \code{\link{get_louvain_communities}} function, the result can be
#' converted into a list of \code{\link{bicluster}} objects with this function.
#' Only biclusters are returned which have a minimum dimension of 2x2.
#'
#' @param coms A list of communities (\code{\link{bicluster_net}}s) as
#' outputted by \code{\link{get_louvain_communities}}.
#' @param bics The list biclusters that was used for calculation
#' with \code{\link{bicluster_network}}.
#' @param mat The numeric matrix, that was used for biclustering.
#' @param row_threshold Minimum fraction of biclusters of a community
#' in which a row needs to occur so that it will be part of the
#' outputted ensemble bicluster.
#' @param col_threshold Minimum fraction of biclusters of a community
#' in which a column needs to occur so that it will be part of the
#' outputted ensemble bicluster.
#' @param threshold_sorted Return the rows and columns in sorted by
#' decreasing fraction.
#' @return A list of \code{\link{bicluster}} objects.
#' 
#' @examples
#' b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'     bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' # m <- matrix(runif(100), nrow=10)
#' # tm = matrix(c(0,1,1,0), nrow=2)
#' # bn <- list(bicluster_net(adjacency_matrix=tm, threshold=.5))
#' # ensemble_biclusters(bn, b, m)
#'
#' @export
ensemble_biclusters <- function(coms, bics, mat, row_threshold = .1,
                                col_threshold = .1, threshold_sorted = FALSE) {
    out_l <- list()
    m_names <- has_names(mat)
    counter <- 1
    # Loop over communities
    for (i in seq(1, length(coms))) {
        # Select biclusters of this community
        tmp_bics <- select_biclusters_from_bicluster_network(coms[[i]], bics)
        if (m_names) {
            atov <- attr_overlap(tmp_bics, named = TRUE)
            atov_r <- atov[atov$type == "row", ]
            ensemble_rows <- atov_r[atov_r$Fraction > row_threshold, ]
            atov_c <- atov[atov$type == "column", ]
            ensemble_cols <- atov_c[atov_c$Fraction > col_threshold, ]
            if (threshold_sorted) {
                ensemble_cols <- 
                    ensemble_cols[order(-ensemble_cols$Fraction), ]
                ensemble_rows <- 
                    ensemble_rows[order(-ensemble_cols$Fraction), ]
            }
            if ((length(atov_r) > 1) & (length(atov_c) > 1)) {
                out_l[[counter]] <- bicluster(
                    row = ensemble_rows$ID,
                    column = ensemble_cols$ID,
                    rowname = ensemble_rows$names,
                    colname = ensemble_cols$names,
                    algorithm = "metabiclustering")
                counter <- counter + 1
            }
        } else {
            atov <- attr_overlap(tmp_bics, named = FALSE)
            atov_r <- atov[atov$type == "row", ]
            ensemble_rows <- atov_r[atov_r$Fraction > row_threshold, ]
            atov_c <- atov[atov$type == "column", ]
            ensemble_cols <- atov_c[atov_c$Fraction > col_threshold, ]
            if ((length(atov_r) > 1) & (length(atov_c) > 1)) {
                out_l[[counter]] <- bicluster(
                    row = ensemble_rows$ID,
                    column = ensemble_cols$ID,
                    algorithm = "metabiclustering"
                )
                counter <- counter + 1}}}
    return(out_l)}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Replace elements of an integer matrix.
#' 
#' This function replaces all elements of an integer matrix, which are under a 
#' certain threshold (<) with zero.
#' 
#' @param m A numeric matrix.
#' @param threshold A numeric threshold under which all elements in the 
#' matrix are replaced by zero.
#' @return An integer matrix.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # replace_threshold(m, 1)
#' 
#' @export
replace_threshold <- function(m, threshold) {
    .Call('_mosbi_replace_threshold', PACKAGE = 'mosbi', m, threshold)
}

#' Generate attribute specific co-occurance networks.
#'
#' The function generates co-occurance networks for all the attributes.
#' E.g. if \code{MARGIN="column"}, for each column, a oc-occurance matrix 
#' of rows is generated, which includes all biclusters, where the 
#' column element is present. 
#' 
#' @param bics A list of \code{\link{bicluster}}s.
#' @param m The matrix used for biclustering.
#' @param MARGIN \code{"row"} or \code{"row"}, Indicating if a list of 
#' row- or column-specific networks is generated
#' @return A list of numeric matrices.
#' If \code{MARGIN="column"} (\code{"row"}), the list has a 
#' length of \code{ncol(m)} (\code{nrow(m)}) 
#' and each matrix the dimensions of \code{c(nrow(m), 
#' nrow(m))} (\code{c(ncol(m), ncol(m))})
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # attribute_graph(bics, m)
#'
#' @export
attribute_graph <- function(bics, m, MARGIN = "column") {
    .Call('_mosbi_attribute_graph', PACKAGE = 'mosbi', bics, m, MARGIN)
}

#' Extract the class-wise degree of an adjacency matrix.
#' 
#' For a adjacency matrix as computed by \code{\link{full_graph}},
#' the function computes how many row-column interactions connect 
#' rows (columns) to columns (rows) of a specific class/category.
#' 
#' @param mat A adjacency matrix with bipartite interactions as 
#' computed by \code{\link{full_graph}} or \code{\link{attribute_graph}} 
#' (with parameter \code{bipartite=TRUE}).
#' @param otherclasses A logical vector indicating two classes 
#' of elements in rows (columns).
#' @param useOther Logical indicating if the attributes, that 
#' are classified appear first in the matrix (\code{True}) or 
#' the attributes that connect classified attributes (\code{False}).
#' @return A DataFrame that holds the total degree of every 
#' attribute (row/column) and the fraction of the degree that 
#' connects only to elements of class \code{True} (from 
#' parameter \code{otherclasses}).
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # fn <- feature_network(bics, m)
#' # attributeConnector(apply_threshold(fn), 
#' #     otherclasses=c(rep(FALSE, 100), rep(TRUE, 100)))
#' 
#' @export
attributeConnector <- function(mat, otherclasses, useOther = FALSE) {
    .Call('_mosbi_attributeConnector', PACKAGE = 'mosbi', mat, otherclasses, useOther)
}

#' Count how often row/column elements occur in biclusters.
#' 
#' Given a list of bicluster objects (\code{\link{bicluster}}), 
#' the function counts the occurance of all elements in the biclusters.
#' 
#' @param bics A list of \code{\link{bicluster}} objects.
#' @param named Boolean, indicating, if all bicluster objects have names.
#' @return A Data Frame with the counts oof all elements.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # attr_overlap(bics, named=FALSE)
#'
#' @export
attr_overlap <- function(bics, named) {
    .Call('_mosbi_attr_overlap', PACKAGE = 'mosbi', bics, named)
}

#' Occurance matrix of data points in a list of biclusters
#' 
#' The function computes a matrix with the same dimensions as the input 
#' matrix and fills the matrix elements with the frequence of occurance 
#' of the data points in the input list of biclusters.
#'  
#' @param bics A list of \code{\link{bicluster}} objects.
#' @param mat The data matrix used for biclustering.
#' @return A numeric matrix with the dimensions of the input matrix. 
#' The values represent the frequency of occurance of this point in 
#' the list of biclusters.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # occurance_matrix(bics, m)
#' 
#' @export
occurance_matrix <- function(bics, mat) {
    .Call('_mosbi_occurance_matrix', PACKAGE = 'mosbi', bics, mat)
}

#' Occurance table of data points in a list of biclusters
#' 
#' The function uses the \code{\link{occurance_matrix}} function and 
#' returns all values higher than the \code{threshold} as a DataFrame.
#' 
#' @param bics A list of \code{\link{bicluster}} objects.
#' @param mat The data matrix used for biclustering.
#' @param threshold Only data points higher than this threshold are returned.
#' @return A DataFrame with the frequencies of occurance for values higher 
#' than a \code{threshold}.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # occurance_table(bics, m, threshold=.1)
#' 
#' @export
occurance_table <- function(bics, mat, threshold = 0.) {
    .Call('_mosbi_occurance_table', PACKAGE = 'mosbi', bics, mat, threshold)
}

#' Indicates, whether a bicluster is valid.
#' That means it needs at least one row and one column.
#' 
#' @param bic A bicluster object
#' @param minRow Minimum number of required rows (Min=1).
#' @param minCol Minimum number of required columns (Min=1).
#' @return Logical indicating a valid bicluster object.
#' 
#' @examples
#' validate_bicluster(bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' 
#' @export
validate_bicluster <- function(bic, minRow = 1L, minCol = 1L) {
    .Call('_mosbi_validate_bicluster', PACKAGE = 'mosbi', bic, minRow, minCol)
}

#' Transpose a bicluster.
#' Row and column slots will be changed.
#' 
#' @param bic A bicluster object.
#' @return A transposed bicluster object,
#' 
#' @examples
#' transpose_bicluster(bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' 
#' @export
transpose_bicluster <- function(bic) {
    .Call('_mosbi_transpose_bicluster', PACKAGE = 'mosbi', bic)
}

#' Clean a list of biclusters, by returning only the valid ones,
#' @param bics A list of bicluster objects.
#' @return A lis tof bicluster objects
#' 
#' @examples
#' b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'         bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' clean_bicluster_list(b)
#' 
#' @export
clean_bicluster_list <- function(bics) {
    .Call('_mosbi_clean_bicluster_list', PACKAGE = 'mosbi', bics)
}

#' Check if a bicluster is a subset (in rows AND columns) 
#' of identical to another bicluster. 
#' 
#' @param bic1 A bicluster.
#' @param bic2 A bicluster.
#' @return 1 if bic1 is a subset of bic2, 2 if bic 1 is 
#' identical to bic2, 0 else.
#' 
#' @examples
#' is_subset_or_identical(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'     bicluster(row=c(1,2,3,4), column=c(1,2,3,4)))
#'     
#' @export
is_subset_or_identical <- function(bic1, bic2) {
    .Call('_mosbi_is_subset_or_identical', PACKAGE = 'mosbi', bic1, bic2)
}

#' Remove all biclusters from a list, that are identical
#' or perfect subsets from each other.
#' Additionally all invalid biclusters are 
#' removed (See \code{\link{validate_bicluster}}).
#' 
#' @param bics A list of bicluster objects
#' @return A list of bicluster objects, where 
#' perfects subsets or identical biclusters are deleted.
#' 
#' @examples
#' filter_subsets(list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'     bicluster(row=c(1,2,3,4), column=c(1,2,3,4))))
#'     
#' @export
filter_subsets <- function(bics) {
    .Call('_mosbi_filter_subsets', PACKAGE = 'mosbi', bics)
}

#' Make a vector of R indices compatible with c++ by 
#' substracting every element by one.
#' @param v A numeric vector.
#' @return A numeric vector with every element decremented by one.
#' 
#' @examples
#' zero_subsetting(c(1,2,3,4,5))
#' 
#' @export
zero_subsetting <- function(v) {
    .Call('_mosbi_zero_subsetting', PACKAGE = 'mosbi', v)
}

#' Subsetting of R matrices within c++.
#'
#' @param m A numeric matrix
#' @param bic A bicluster object.
#' @return Matrix subset.
#' 
#' @examples
#' cpp_matrix_subsetting(matrix(seq(1:16), nrow=4), 
#'     bicluster(row=c(1,2), column=c(1,2)))
#'     
#' @export
cpp_matrix_subsetting <- function(m, bic) {
    .Call('_mosbi_cpp_matrix_subsetting', PACKAGE = 'mosbi', m, bic)
}

#' Filter a list of bicluster objects, by erasing all biclusters, 
#' that do not fulfill the minimum number of rows and columns.
#' Utilizes the function \code{\link{validate_bicluster}}.
#' 
#' @param bics List of bicluster objects.
#' @param minRow Minimum number of rows.
#' @param minCol Minimum number of columns.
#' @return A filtered list of bicluster objects.
#' 
#' @examples
#' b <- list(bicluster(row=c(1,2), column=c(1,2,3,4)),
#'         bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' filter_bicluster_size(b, 3, 3)
#' 
#' @export
filter_bicluster_size <- function(bics, minRow, minCol) {
    .Call('_mosbi_filter_bicluster_size', PACKAGE = 'mosbi', bics, minRow, minCol)
}

#' Save adjacency matrix as GraphML file
#' 
#' Save and adjacency matrix as returned by \code{\link{full_graph}} or 
#' 1 - \code{\link{distance_matrix}} as a GraphML file.
#' 
#' @param m A symmetric numeric matrix (Adjacency matrix). Rownames 
#' are considered as node names.
#' @param filename Name of the resulting GraphML 
#' file (should end with ".gml").
#' @param cols Node colors.
#' @return 0 if successful.
#' @import BH
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # write_graphml(apply_threshold(bn), "testfile.txt")
#' 
#' @export
write_graphml <- function(m, filename, cols) {
    .Call('_mosbi_write_graphml', PACKAGE = 'mosbi', m, filename, cols)
}

#' Detect the number of elements in a list of biclusters.
#' 
#' Finds the highest element in a list of bicluster objects.
#'
#' @param bics A list of bicluster objects.
#' @param MARGIN Choose if the distance is computed over \code{"row"} 
#' or \code{"column"}.
#' @return Return highest row or column index from a list of biclusters.
#' 
#' @examples
#' b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'         bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' detect_elements(b)
#' 
#' @export
detect_elements <- function(bics, MARGIN = "row") {
    .Call('_mosbi_detect_elements', PACKAGE = 'mosbi', bics, MARGIN)
}

#' Compute similarities between biclusters
#' 
#' This function computes a similarity matrix between biclusters using
#' different similarity metrics.
#' 
#' @param bics A list of bicluster objects.
#' @param MARGIN Choose if the distance is computed over \code{"row"}
#' , \code{"column"} or \code{"both"}.
#' @param metric Integer indicating which metric is used. 
#' 1: Bray-Curtis similarity (default), 2: Jaccard index, 
#' 3: overlap coefficient, 4: Fowlkes–Mallows index.
#' @param prob_scale Scale similarity by the probability of an 
#' overlap equal of higher to the observed one. The scaling is 
#' done by multiplying the similarity 
#' with \code{(1 - (1 / (1 - log(overlap_probability, base=100))))}. 
#' The probability is comupted using the 
#' function \code{\link{p_overlap_2d_higher}} 
#' for \code{MARGIN =="both"} and  \code{\link{p_overlap_higher}} 
#' otherwise. Can be helpful for big imbalances of bicluster sizes.
#' @param mat_row If \code{prob_scale == TRUE}, the number of rows of the 
#' input matrix for biclustering must be given.
#' @param mat_col If \code{prob_scale == TRUE}, the number of columns of 
#' the input matrix for biclustering must be given.
#' @param prl Compute the similarity matrix using multiple 
#' cores (works only for \code{MARGIN="both"}). The number of 
#' core can be defined by 
#' executing: \code{RcppParallel::setThreadOptions(numThreads = 4)} 
#' before running this function.
#' @return A numeric matrix of the similarities between all given biclusters.
#' 
#' @examples
#' b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'         bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' similarity_matrix(b)
#'
#' @export
similarity_matrix <- function(bics, MARGIN = "both", metric = 1L, prob_scale = FALSE, mat_row = 0L, mat_col = 0L, prl = FALSE) {
    .Call('_mosbi_similarity_matrix', PACKAGE = 'mosbi', bics, MARGIN, metric, prob_scale, mat_row, mat_col, prl)
}

#' Compute distances between biclusters
#' 
#' This function computes a distance matrix between biclusters using 
#' different dissimilarity metrics.
#' 
#' @param bics A list of bicluster objects.
#' @param MARGIN Choose if the distance is computed over \code{"row"} 
#' or \code{"column"}.
#' @param metric Integer indicating which metric is used. 1: Bray-Curtis 
#' dissimilarity (default), 2: Jaccard distance, 3: 1-overlap coefficient  
#' 4: 1 - Fowlkes–Mallows index.
#' @return A numeric matrix of the dissimilarities between all 
#' given biclusters.
#' 
#' @examples
#' b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'         bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' distance_matrix(b)
#'
#' @export
distance_matrix <- function(bics, MARGIN = "row", metric = 1L) {
    .Call('_mosbi_distance_matrix', PACKAGE = 'mosbi', bics, MARGIN, metric)
}

#' Probability for an overlap of two samples.
#' 
#' The probability is computed using the 
#' forumla \eqn{\frac{{y \choose x}\times {n-y \choose k-x}}{{n \choose k}}}.
#' 
#' @param x Overlap.
#' @param y Size of sample 1.
#' @param k Size of Sample 2.
#' @param n Number of all elements sampled from.
#' @return Overlap probability.
#' 
#' @examples
#' p_overlap(10, 20, 30, 100)
#'
#' @export
p_overlap <- function(x, y, k, n) {
    .Call('_mosbi_p_overlap', PACKAGE = 'mosbi', x, y, k, n)
}

#' Probability for an overlap higher or equal to the observed 
#' one of two samples
#' 
#' Is computed by adding up probabilities for all possible 
#' overlaps equal or higher to the observed one using the 
#' function \code{\link{p_overlap}}.
#' 
#' @param x Overlap.
#' @param y Size of sample 1.
#' @param k Size of Sample 2.
#' @param n Number of all elements sampled from.
#' @return Overlap probability.
#' 
#' @examples
#' p_overlap_higher(10, 20, 30, 100)
#' 
#' @export
p_overlap_higher <- function(x, y, k, n) {
    .Call('_mosbi_p_overlap_higher', PACKAGE = 'mosbi', x, y, k, n)
}

#' Probability for an overlap of two dimensional samples
#' 
#' Is computed by calculating the overlap probability for each 
#' dimension independently and multiplying them using the 
#' function \code{\link{p_overlap}}.
#' 
#' @param ov_x Overlap in the first dimension.
#' @param ov_y Overlap in the second dimension.
#' @param s1x First sample of the first dimension.
#' @param s1y First sample of the second dimension.
#' @param s2x Second sample of first dimension.
#' @param s2y Second sample of the second dimension.
#' @param mat_x Number of all elements from the first 
#' dimension sampled from.
#' @param mat_y Number of all elements from the second 
#' dimension sampled from.
#' @return Overlap probability.
#' 
#' @examples
#' p_overlap_2d(10, 10, 20, 20, 30, 30, 100, 100)
#' 
#' @export
p_overlap_2d <- function(ov_x, ov_y, s1x, s1y, s2x, s2y, mat_x, mat_y) {
    .Call('_mosbi_p_overlap_2d', PACKAGE = 'mosbi', ov_x, ov_y, s1x, s1y, s2x, s2y, mat_x, mat_y)
}

#' Probability for an overlap higher or equal to the observed one 
#' of two dimensional samples
#' 
#' Is computed by adding up probabilities for all combinations of 
#' the observed or higher overlaps using the 
#' function \code{\link{p_overlap_2d}}.
#' 
#' @param ov_x Overlap in the first dimension.
#' @param ov_y Overlap in the second dimension.
#' @param s1x First sample of the first dimension.
#' @param s1y First sample of the second dimension.
#' @param s2x Second sample of first dimension.
#' @param s2y Second sample of the second dimension.
#' @param mat_x Number of all elements from the first 
#' dimension sampled from.
#' @param mat_y Number of all elements from the second 
#' dimension sampled from.
#' @return Overlap probability
#' 
#' @examples
#' p_overlap_2d_higher(10, 10, 20, 20, 30, 30, 100, 100)
#' 
#' @export
p_overlap_2d_higher <- function(ov_x, ov_y, s1x, s1y, s2x, s2y, mat_x, mat_y) {
    .Call('_mosbi_p_overlap_2d_higher', PACKAGE = 'mosbi', ov_x, ov_y, s1x, s1y, s2x, s2y, mat_x, mat_y)
}

#' Get the number of biclusters, generated by the Bi-Force algorithm.
#' @param filename Name of the Bi-Force output file.
#' @return Number of biclusters.
#' 
#' @examples
#' a <- "PathToBiForceOutput.txt"
#' # NoBFBiclusters(a)
#' 
#' @export
NoBFBiclusters <- function(filename) {
    .Call('_mosbi_NoBFBiclusters', PACKAGE = 'mosbi', filename)
}

#' Get a bicluster a Bi-Force output file
#' @param filename Name of the Bi-Force output file.
#' @param cluster Number of the bicluster that should be extracted.
#' @return Bicluster as list with rownames in attribute "row" 
#' and colnames in attribute "column".
#' 
#' @examples
#' a <- "PathToBiForceOutput.txt"
#' # getBFCluster(a, cluster=1)
#' 
#' @export
getBFCluster <- function(filename, cluster) {
    .Call('_mosbi_getBFCluster', PACKAGE = 'mosbi', filename, cluster)
}

#' Get all biclusters from a Bi-Force output file.
#' @param filename Name of the Bi-Force output file.
#' @return List of biclusters in the form of \code{\link{getBFCluster}}
#' 
#' @examples
#' a <- "PathToBiForceOutput.txt"
#' # getallBFClusters(a)
#' 
#' 
#' @export
getallBFClusters <- function(filename) {
    .Call('_mosbi_getallBFClusters', PACKAGE = 'mosbi', filename)
}

#' Extract QUBIC2 biclusters
#' 
#' Extract biclusters from a QUBIC2 "*.blocks" file. 
#' Row and column names are not added to the bicluster objects.
#' @param filename Path to the QUBIC2 results file.
#' @param transposed Set to TRUE, if the
#' biclustering was performed on a tranposed matrix.
#' @return A list of validated bicluster 
#' objects (See \code{\link{validate_bicluster}}).
#' 
#' @examples
#' a <- "PathToQUBIC2output.txt"
#' # Not run: getQUBIC2biclusters(a)
#' 
#' @export
getQUBIC2biclusters <- function(filename, transposed = FALSE) {
    .Call('_mosbi_getQUBIC2biclusters', PACKAGE = 'mosbi', filename, transposed)
}

#' Generate a similarity network for a list of biclusters
#' 
#' The function computes a adjacency 
#' matrix for rows and columns of biclusters.
#' The matrix values show, how often two rows or two columns or a row and a 
#' column occur together in biclusters.
#' In the resulting adjacency matrix, rows are listed first, followed 
#' by columns. 
#' They have the same order as the the rows and columns of the input matrix.
#' 
#' In case the given biclusters have overall more or less columns than rows, 
#' the interactions can be weighted to visualize the result properly.
#' @param bics A list of biclusters.
#' @param m The matrix, that was used to calculated the biclusters.
#' @param rr_weight Weight row-row interactions.
#' @param rc_weight Weight row-col interactions.
#' @param cc_weight Weight col-col interactions.
#' @param weighting Weight interactions by bicluster size. 0 - no weighting, 
#' 1 - multiply by bicluster size, 2 - divide by bicluster size.
#' @return An adjacency matrix.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
#'         bicluster(row=c(3,4,5,6), column=c(3,4,5,6)),
#'         bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
#' # full_graph(b, m)
#' 
#' @export
full_graph <- function(bics, m, rr_weight = 1L, rc_weight = 1L, cc_weight = 1L, weighting = 0L) {
    .Call('_mosbi_full_graph', PACKAGE = 'mosbi', bics, m, rr_weight, rc_weight, cc_weight, weighting)
}

#' Check, whether a matrix has row- and colnames.
#' @param m A matrix
#' @return Logical indicating existence of row- and colnames.
#' 
#' @examples
#' has_names(matrix(c(1,2,3,4), nrow=2))
#' 
#' m <- matrix(c(1,2,3,4), nrow=2)
#' rownames(m) <- c("r1", "r2")
#' rownames(m) <- c("c1", "c2")
#' has_names(m)
#' 
#' @export
has_names <- function(m) {
    .Call('_mosbi_has_names', PACKAGE = 'mosbi', m)
}

#' Throw an error, if a matrix has not both row- and colnames.
#' @param m A matrix.
#' @return Throws error, if matrix has no row- and column names.
#' 
#' @examples 
#' m <- matrix(c(1,2,3,4), nrow=2)
#' rownames(m) <- c("r1", "r2")
#' colnames(m) <- c("c1", "c2")
#' check_names(m)
#' 
#' @export
check_names <- function(m) {
    invisible(.Call('_mosbi_check_names', PACKAGE = 'mosbi', m))
}

#' Replace values in an integer adjacency matrix.
#'
#' Replace values in an integer matrix, that are lower than a certain 
#' threshold.
#'
#' @param mat An integer matrix
#' @param threshold All values in the matrix lower than this values are 
#' replaced by 0.
#' @param replace_higher If set to true, all values >= \code{threshold} 
#' are replaced by 1.
#' @return An integer matrix with (partially) replaced values.
#' 
#' @examples
#' replace_values(matrix(seq(1, 16), nrow=4), threshold=4)
#'
#' @export
replace_values <- function(mat, threshold, replace_higher = TRUE) {
    .Call('_mosbi_replace_values', PACKAGE = 'mosbi', mat, threshold, replace_higher)
}

#' Replace values in a adjacency matrix.
#' 
#' Same as \code{\link{replace_values}}, but for (positive) non-integer
#' matrices.
#'
#' Replace values in a numeric matrix, that are lower than a certain 
#' threshold.
#'
#' @param mat A numeric matrix
#' @param threshold All values in the matrix lower than this values are 
#' replaced by 0.
#' @param replace_higher If set to true, all values >= \code{threshold} 
#' are replaced by 1.
#' @return A numeric matrix with (partially) replaced values.
#' 
#' @examples
#' replace_values(matrix(rnorm(100), nrow=10), threshold=1)
#'
#' @export
replace_values_float <- function(mat, threshold, replace_higher = TRUE) {
    .Call('_mosbi_replace_values_float', PACKAGE = 'mosbi', mat, threshold, replace_higher)
}

#' Count edges in an adjacency matrix using different cut-off thresholds.
#' 
#' Computes the how many edges remain in a network if edges with a weight 
#' lower than a certain threshold are removed.
#' The number of remaining edges between 1 and max(adjm) are calculated.
#' It is assumend that the matrix is symmetric and therefore the number 
#' of edges divided by two.
#' Uses the function \code{\link{replace_values}}.
#' 
#' @param adjm A symmetrix numeric matrix.
#' @return A numeirc matrix of \code{dim(max(adjm), 2)}. The first column 
#' indicated the applied threshold, the second column the remaining edges.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # fn <- feature_network(bics, m)
#' # network_edge_strength(apply_threshold(fn))
#' 
#' @export
network_edge_strength <- function(adjm) {
    .Call('_mosbi_network_edge_strength', PACKAGE = 'mosbi', adjm)
}

#' Count edges in an adjacency matrix using different cut-off 
#' thresholds.
#'
#' Same as \code{\link{network_edge_strength}}, but for (positive) 
#' non-integer matrices.
#' 
#' Computes the how many edges remain in a network if edges with a 
#' weight lower than a certain threshold are removed.
#' The number of remaining edges between 1 and max(adjm) are calculated.
#' It is assumend that the matrix is symmetric and therefore 
#' the number of edges divided by two.
#' Uses the function \code{\link{replace_values_float}}.
#' 
#' @param adjm A symmetrix numeric matrix.
#' @param steps Number of steps for which the edge count is evaluated.
#' @param maximum Highest value until which the edge weight is evaluated. 
#' If maximum=0, the max value of \code{adjm} is used.
#' @return A numeirc matrix of \code{dim(max(adjm), 2)}. 
#' The first column indicated the applied threshold, the second 
#' column the remaining edges.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # network_edge_strength_float(apply_threshold(bn))
#'
#' @export
network_edge_strength_float <- function(adjm, steps = 100L, maximum = 0) {
    .Call('_mosbi_network_edge_strength_float', PACKAGE = 'mosbi', adjm, steps, maximum)
}

#' Get the rowlengths for a list of bicluster objects.
#' 
#' Can be used for e.g. histograms.
#' @param bic A list  of bicluster objects.
#' @return A vector with the lenghts of the rows in every bicluster object.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # rowhistogram(bics)
#' 
#' @export
rowhistogram <- function(bic) {
    .Call('_mosbi_rowhistogram', PACKAGE = 'mosbi', bic)
}

#' Get the columnlengths for a list of bicluster objects.
#' 
#' Can be used for e.g. histograms.
#' @param bic A list  of bicluster objects.
#' @return A vector with the lenghts of the columns in every bicluster object.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # colhistogram(bics)
#' 
#' @export
colhistogram <- function(bic) {
    .Call('_mosbi_colhistogram', PACKAGE = 'mosbi', bic)
}

#' Get list the list of algorithms from a list of bicluster objects.
#' 
#' Can be used for .g. histograms.
#' @param bic A list  of bicluster objects.
#' @return A character vector with the extracted biclustering algorithms 
#' used for each bicluster of the input list.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # algohistogram(bics)
#' 
#' @export
algohistogram <- function(bic) {
    .Call('_mosbi_algohistogram', PACKAGE = 'mosbi', bic)
}

#' Sample a list of biclusters.
#' 
#' The function generates a list of biclusters given an input list of 
#' biclusters, where each bicluster has the same number or rows and columns, 
#' but with sampled entries from a uniform distribution of all rows and 
#' columns is the matrix.
#' @param bics A list of validated bicluster objects.
#' @param mat The numeric matrix, that was used to generate the biclusters.
#' @return A list of \link{bicluster} objects.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # sample_biclusters(bics, m)
#' 
#' @export
sample_biclusters <- function(bics, mat) {
    .Call('_mosbi_sample_biclusters', PACKAGE = 'mosbi', bics, mat)
}

#' Write an R matrix to a file (In a Bi-Force or QUBIC2 readable format).
#' @param m A Numeric matrix.
#' @param filename Name of the output file.
#' @param qubic2_format Write the matrix in a format QUBIC2 is able to read. 
#' This means adding a row- and column names to the file.
#' @return 0 if file was written successfully.
#' 
#' @examples
#' write_matrix(matrix(c(1,2,3,4), nrow=2), "testfile.txt")
#' 
#' @export
write_matrix <- function(m, filename, qubic2_format = FALSE) {
    .Call('_mosbi_write_matrix', PACKAGE = 'mosbi', m, filename, qubic2_format)
}

test_that("Bicluster network", code = {
    bics <- list(bicluster(row=c(1, 2), column = c(1, 2)),
                bicluster(row=c(2, 3), column=c(2, 3)))
    
    sim1 <- similarity_matrix(bics, MARGIN = "both")
    
    bn <- bicluster_net(adjacency_matrix = sim1, 
                       threshold=.3, 
                       algorithms = "test")
    
    
    expect_equal(apply_threshold(bn), matrix(c(1, 0, 0, 1), nrow=2, 
                             dimnames=(list(c("bicluster1", 
                                              "bicluster2"), 
                                            c("bicluster1", 
                                              "bicluster2")))))
    
    expect_equal(get_adjacency(bn), sim1)
    
    expect_s3_class(bicluster_net_to_igraph(bn), "igraph")
    
    expect_equal(get_louvain_communities(bn), list())
}
)

test_that("C++ methods", code = {
    bics <- list(bicluster(row=c(1, 2), column = c(1, 2)),
                bicluster(row=c(2, 3), column=c(2, 3)))
    
    sim1 <- similarity_matrix(bics, MARGIN = "both")
    
    bn <- bicluster_net(adjacency_matrix = sim1, 
                       threshold=.3, 
                       algorithms = "test")
    
    expect_equal(detect_elements(bics), 3)
    
    m <- matrix(c(1:9), nrow=3)
    
    fg <- full_graph(bics, m)
    
    expect_equal(sum(fg), 24)
}
)

test_that("Similarity computation", code = {
    bics <- list(bicluster(row=c(1, 2), column = c(1, 2)),
                bicluster(row=c(2, 3), column=c(2, 3)))
    
    # Different margins
    sim1 <- similarity_matrix(bics, MARGIN = "both")
    expect_equal(sim1, matrix(c(1, .25, .25, 1), nrow=2, 
                              dimnames=(list(c("bicluster1", "bicluster2"), 
                                             c("bicluster1", "bicluster2")))))
    
    sim2 <- similarity_matrix(bics, MARGIN = "row")
    expect_equal(sim2, matrix(c(1, .5, .5, 1), nrow=2, 
                              dimnames=(list(c("bicluster1", "bicluster2"), 
                                             c("bicluster1", "bicluster2")))))
    
    sim3 <- similarity_matrix(bics, MARGIN = "column")
    expect_equal(sim3, matrix(c(1, .5, .5, 1), nrow=2, 
                              dimnames=(list(c("bicluster1", "bicluster2"), 
                                             c("bicluster1", "bicluster2")))))
    
    # Different metrics
    sim <- similarity_matrix(bics, MARGIN = "both", metric = 2)
    expect_equal(round(sim, 2), matrix(c(1, 0.14, 0.14, 1), nrow=2, 
                                    dimnames=(list(c("bicluster1", 
                                                     "bicluster2"), 
                                                c("bicluster1", 
                                                  "bicluster2")))))
    
    sim <- similarity_matrix(bics, MARGIN = "both", metric = 3)
    expect_equal(sim, matrix(c(1, .25, .25, 1), nrow=2, 
                                       dimnames=(list(c("bicluster1", 
                                                        "bicluster2"), 
                                                      c("bicluster1", 
                                                        "bicluster2")))))
    
    sim <- similarity_matrix(bics, MARGIN = "both", metric = 4)
    expect_equal(sim, matrix(c(1, 0, 0, 1), nrow=2, 
                             dimnames=(list(c("bicluster1", 
                                              "bicluster2"), 
                                            c("bicluster1", 
                                              "bicluster2")))))
    
})

#' Mouse brain lipidomics data
#' 
#' Development of the mice brain lipidome over several weeks.
#' 
#' @format A data frame with 245 rows and 61 columns
#' 
#' @source \url{https://www.ebi.ac.uk/metabolights/MTBLS562}
#' 
#' @usage data(mouse_data)
#' 
#' @examples 
#' # data(mouse_data)
#' # View(mouse_data)
"mouse_data"

#' @include bicluster.R
NULL

#' Apply a threshold to a bicluster similarity adjacency matrix or a
#' co-occurrence adjacency matrix.
#'
#' All values lower than the threshold will be replaced by a 0.
#'
#' @param bic_net An object of class \code{bicluster_net}
#' or \code{cooccurrence_net}.
#' @return An adjacency matrix with the applied threshold.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # apply_threshold(bn)
#' 
#' @export
methods::setGeneric("apply_threshold", function(bic_net) {
    methods::standardGeneric("apply_threshold")
})

#' Apply a threshold to a bicluster similarity adjacency matrix.
#'
#' All values lower than the threshold will be replaced by a 0.
#'
#' @param bic_net An object of class \code{bicluster_net}.
#' @return An adjacency matrix with the applied threshold.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # apply_threshold(bn)
#' 
#' @export
methods::setMethod(
    "apply_threshold",
    c(bic_net = "bicluster_net"),
    function(bic_net) {
        tmp <- bic_net@adjacency_matrix
        return(replace_values_float(tmp, bic_net@threshold,
            replace_higher = FALSE
        ))
    }
)


#' Get Adjacency matrix
#'
#' Return Adjacency matrix from bicluster network
#'
#' @param bic_net An object of class \code{bicluster_net}.
#' @return Raw unfiltered adjacency matrix.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # get_adjacency(bn)
#' 
#' @export
methods::setGeneric("get_adjacency", function(bic_net) {
    methods::standardGeneric("get_adjacency")
})

#' Get Adjacency matrix
#'
#' Return Adjacency matrix from bicluster network
#'
#' @param bic_net An object of class \code{bicluster_net}.
#' @return Raw unfiltered adjacency matrix.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # get_adjacency(bn)
#' 
#' @export
methods::setMethod(
    "get_adjacency",
    c(bic_net = "bicluster_net"),
    function(bic_net) {
        return(bic_net@adjacency_matrix)
    }
)

#' Get bicluster network algorithms
#'
#' Return algorithms from bicluster network
#'
#' @param bic_net An object of class \code{bicluster_net}.
#' @return Algorithm names as characters.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # get_bic_net_algorithms(bn)
#' 
#' @export
methods::setGeneric("get_bic_net_algorithms", function(bic_net) {
    methods::standardGeneric("get_bic_net_algorithms")
})

#' Get bicluster network algorithms
#'
#' Return algorithms from bicluster network
#'
#' @param bic_net An object of class \code{bicluster_net}.
#' @return Algorithm names as characters.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # get_bic_net_algorithms(bn)
#' 
#' @export
methods::setMethod(
    "get_bic_net_algorithms",
    c(bic_net = "bicluster_net"),
    function(bic_net) {
        return(bic_net@algorithms)
    }
)

#' Apply a threshold to a co-occurrence adjacency matrix.
#'
#' All values lower than the threshold will be replaced by a 0.
#'
#' @param bic_net An object of class \code{cooccurrence_net}.
#' @return An adjacency matrix with the applied threshold.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # fn <- feature_network(bics, m)
#' # apply_threshold(fn)
#' 
#' @export
methods::setMethod(
    "apply_threshold",
    c(bic_net = "cooccurrence_net"),
    function(bic_net) {
        tmp <- bic_net@adjacency_matrix
        return(replace_values_float(tmp, bic_net@threshold,
            replace_higher = FALSE
        ))
    }
)


#' Convert Bicluster network to an igraph graph object
#'
#' The function converts a \code{\link{bicluster_net}} object into an igraph
#' graph object.
#' The \code{threshold} is used as a cutoff for the edges of the network.
#'
#' @param bic_net An object of class \code{bicluster_net}.
#' @return An \code{igraph::\link[igraph]{graph}} object.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # bicluster_net_to_igraph(bn)
#' 
#' @export
methods::setGeneric("bicluster_net_to_igraph", function(bic_net) {
    methods::standardGeneric("bicluster_net_to_igraph")
})

#' Convert Bicluster network to an igraph graph object
#'
#' The function converts a \code{\link{bicluster_net}} object into an igraph
#' graph object.
#' The \code{threshold} is used as a cutoff for the edges of the network.
#'
#' @param bic_net An object of class \code{bicluster_net}.
#' @return An \code{igraph::\link[igraph]{graph}} object.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # bicluster_net_to_igraph(bn)
#' 
#' @export
methods::setMethod(
    "bicluster_net_to_igraph",
    c(bic_net = "bicluster_net"),
    function(bic_net) {
        return(igraph::simplify(igraph::graph.adjacency(
            apply_threshold(bic_net),
            mode = "undirected",
            weighted = TRUE
        )))
    }
)


#' Convert a co-occurence network to an igraph graph object
#'
#' The function converts a \code{\link{cooccurrence_net}} object into an
#' igraph graph object.
#' The \code{threshold} is used as a cutoff for the edges of the network.
#'
#' @param occ_net An object of class \code{cooccurrence_net}.
#' @return An \code{igraph::\link[igraph]{graph}} object.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # fn <- feature_network(bics, m)
#' # cooccurrence_net_to_igraph(fn)
#' 
#' 
#' @export
methods::setGeneric("cooccurrence_net_to_igraph", function(occ_net) {
    methods::standardGeneric("cooccurrence_net_to_igraph")
})

#' Convert a co-occurrence to an igraph graph object
#'
#' The function converts a \code{\link{cooccurrence_net}} object into an
#' igraph graph object.
#' The \code{threshold} is used as a cutoff for the edges of the network.
#'
#' @param occ_net An object of class \code{cooccurrence_net}.
#' @return An \code{igraph::\link[igraph]{graph}} object.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # fn <- feature_network(bics, m)
#' # cooccurrence_net_to_igraph(fn)
#' 
#' @export
methods::setMethod(
    "cooccurrence_net_to_igraph",
    c(occ_net = "cooccurrence_net"),
    function(occ_net) {
        return(igraph::simplify(igraph::graph.adjacency(
            apply_threshold(bic_net = occ_net),
            mode = "undirected",
            weighted = TRUE
        )))
    }
)

# Plot ----

#' Plot a bicluster network
#'
#' Converts the object into a \link[igraph]{graph} and uses its plot function.
#'
#' @param x An object of class \code{\link{bicluster_net}}.
#' @param y Not used.
#' @param ... Plot parameters forwarded
#' to \code{igraph::\link[igraph]{plot.igraph}}
#' @return An \link[igraph]{graph} plot.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # plot(bn)
#' 
#' @export
methods::setMethod(
    "plot",
    c(x = "bicluster_net", y = "missing"),
    function(x, y, ...) {
        igraph::plot.igraph(bicluster_net_to_igraph(x), ...)
    }
)

#' Plot a co-occurrence network
#'
#' Converts the object into a \link[igraph]{graph} and uses its plot function.
#'
#' @param x An object of class \code{\link{cooccurrence_net}}.
#' @param y Not used.
#' @param ... Plot parameters forwarded
#' to \code{igraph::\link[igraph]{plot.igraph}}
#' @return An \link[igraph]{graph} plot.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # fn <- feature_network(bics, m)
#' # plot(fn)
#' 
#' @export
methods::setMethod(
    "plot",
    c(x = "cooccurrence_net", y = "missing"),
    function(x, y, ...) {
        igraph::plot.igraph(
            cooccurrence_net_to_igraph(occ_net = x), ...
        )
    }
)


get_communities <- function(com) {
    num_com <- length(com)
    ms <- igraph::membership(com)
    out <- list()
    for (i in seq(1, num_com)) {
        out[[i]] <- (seq(1, length(ms)))[igraph::membership(com) == i]
    }
    return(out)
}

# Louvain communities ----

#' Get louvain communities from a bicluster network
#'
#' Extracts the louvain communities from a \code{\link{bicluster_net}}
#' or \code{\link{cooccurrence_net}} object using the louvain modularity
#' optimization from the \code{igraph}
#' package (\code{\link[igraph]{cluster_louvain}}).
#'
#' @param bic_net A \code{\link{bicluster_net}}
#' or \code{\link{cooccurrence_net}}object.
#' @param min_size Minimum size of a louvain community to be
#' returned (minimum value is 2).
#' @param bics Optional. Is only use for the class \code{\link{bicluster_net}}.
#'  The respective list of biclusters to identify,
#'  from which algorithms a community originates.
#' @return A list of \code{\link{bicluster_net}}
#' or \code{\link{cooccurrence_net}} objects.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # get_louvain_communities(bn)
#' 
#' @export
methods::setGeneric("get_louvain_communities", function(bic_net,
                                                        min_size = 2,
                                                        bics = NULL) {
    methods::standardGeneric("get_louvain_communities")
})


#' Get louvain communities from a bicluster network
#'
#' Extracts the louvain communities from a \code{\link{bicluster_net}}
#' object using the louvain modularity optimization from the \code{igraph}
#' package (\code{\link[igraph]{cluster_louvain}}).
#'
#' @param bic_net A \code{\link{bicluster_net}} object.
#' @param min_size Minimum size of a louvain community to
#' be returned.
#' @param bics Optional. The respective list of biclusters to identify,
#' from which algorithms a community originates.
#' @return A list of \code{\link{bicluster_net}} objects.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # get_louvain_communities(bn)
#' 
#' @export
methods::setMethod("get_louvain_communities",
    # c(bic_net="bicluster_net", min_size="numeric"),
    signature = "bicluster_net",
    definition = function(bic_net, min_size = 2, bics = NULL) {
        
        net <- bicluster_net_to_igraph(bic_net)
        coms <- mosbi:::get_communities(igraph::cluster_louvain(net))
        out_l <- list()
        for (i in seq(1, length(coms))) {
            if (length(coms[[i]]) >= min_size) {
                if (!is.null(bics)) {
                    
                    if (length(coms[[i]]) > 1) {
                        tmp_b <- bicluster_net(
                            adjacency_matrix =
                                bic_net@adjacency_matrix[
                                    coms[[i]],
                                    coms[[i]]
                                ],
                            threshold = bic_net@threshold
                        )
                    } else {
                        uc_tmp <- matrix(bic_net@adjacency_matrix[coms[[i]], coms[[i]]])
                        rownames(uc_tmp) <- c(paste0("bicluster", coms[[i]]))
                        colnames(uc_tmp) <- c(paste0("bicluster", coms[[i]]))
                        out_l[[length(out_l) + 1]] <- bicluster_net(
                            adjacency_matrix = uc_tmp,
                            threshold = bic_net@threshold
                        )
                    }
                    
                    algs <- get_algorithms(
                        select_biclusters_from_bicluster_network(
                            tmp_b,
                            bics
                        )
                    )
                    
                    out_l[[length(out_l) + 1]] <- bicluster_net(
                        adjacency_matrix = tmp_b@adjacency_matrix,
                        threshold = tmp_b@threshold, algorithms = algs
                    )
                    
                } else {
                    if (length(coms[[i]]) > 1) {
                        out_l[[length(out_l) + 1]] <- bicluster_net(
                            adjacency_matrix =
                                bic_net@adjacency_matrix[coms[[i]], coms[[i]]],
                            threshold = bic_net@threshold
                        )
                    } else { # For the case of unconnected biclusters
                        uc_tmp <- matrix(bic_net@adjacency_matrix[coms[[i]], coms[[i]]])
                        rownames(uc_tmp) <- c(paste0("bicluster", coms[[i]]))
                        colnames(uc_tmp) <- c(paste0("bicluster", coms[[i]]))
                        out_l[[length(out_l) + 1]] <- bicluster_net(
                            adjacency_matrix = uc_tmp,
                            threshold = bic_net@threshold
                        )
                        
                    }
                }
            }
        }
        return(out_l)
    }
)

#' Get louvain communities from a co-occurrence network
#'
#' Extracts the louvain communities from a \code{\link{cooccurrence_net}}
#' object using the louvain modularity optimization from the \code{igraph}
#' package (\code{\link[igraph]{cluster_louvain}}).
#'
#' @param bic_net A \code{\link{cooccurrence_net}} object.
#' @param min_size Minimum size of a louvain community to be
#' returned (minimum value is 2).
#' @param bics Not used.
#' @return A list of \code{\link{cooccurrence_net}} objects.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # fn <- feature_network(bics, m)
#' # get_louvain_communities(fn)
#' 
#' @export
methods::setMethod("get_louvain_communities",
    # c(bic_net="bicluster_net", min_size="numeric"),
    signature = "cooccurrence_net",
    definition = function(bic_net, min_size = 2, bics = NULL) {
        if (min_size < 2) {
            min_size <- 2
            warning("Minimum value for parameter 'min_size' is 2.
                The input value has been replaced by 2.")
        }
        net <- cooccurrence_net_to_igraph(bic_net)
        coms <- get_communities(igraph::cluster_louvain(net))
        out_l <- list()
        for (i in seq(1, length(coms))) {
            if (length(coms[[i]]) >= min_size) {
                out_l[[length(out_l) + 1]] <- cooccurrence_net(
                    adjacency_matrix =
                        bic_net@adjacency_matrix[coms[[i]], coms[[i]]],
                    threshold = bic_net@threshold
                )
            }
        }
        return(out_l)
    }
)





extract_biclusters_from_rownames <- function(bic_net) {
    return(as.numeric(substring(rownames(bic_net@adjacency_matrix), 10)))
}


#' Create a subset of biclusters based on a bicluster network
#'
#' The function returns an adapted bicluster list based on
#' a \code{\link{bicluster_net}} object.
#' This might be necessary e.g. after \code{\link{get_louvain_communities}}
#' was used a community consists only of a subset of the biclusters.
#' @param bic_net A \code{\link{bicluster_net}}.
#' @param bics A list of \code{\link{bicluster}} objects as returned
#' by \code{\link{get_biclusters}}.
#' @return A subsetted list of \code{\link{bicluster}} objects
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # lc <- get_louvain_communities(bn)
#' # select_biclusters_from_bicluster_network(lc[[1]], bics)
#' 
#' @export
methods::setGeneric(
    "select_biclusters_from_bicluster_network",
    function(bic_net, bics) {
        methods::standardGeneric("select_biclusters_from_bicluster_network")
    }
)

#' Create a subset of biclusters based on a bicluster network
#'
#' The function returns an adapted bicluster list based on
#' a \code{\link{bicluster_net}} object.
#' This might be necessary e.g. after \code{\link{get_louvain_communities}}
#' was used and a community consists only of a subset of the biclusters.
#' @param bic_net A \code{\link{bicluster_net}}.
#' @param bics A list of \code{\link{bicluster}} objects as returned
#' by \code{\link{get_biclusters}}.
#' @return A subsetted list of \code{\link{bicluster}} objects.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # lc <- get_louvain_communities(bn)
#' # select_biclusters_from_bicluster_network(lc[[1]], bics)
#' 
#' @export
methods::setMethod(
    "select_biclusters_from_bicluster_network",
    c(bic_net = "bicluster_net", bics = "list"),
    function(bic_net, bics) {
        bics[extract_biclusters_from_rownames(bic_net)]
    }
)

check_pie <- function(bic_pie) {
    is_all_zero <- function(x) all(x == 0)

    if (any(vapply(bic_pie, is_all_zero, FALSE))) {
        stop("Each bicluster needs at least one member with a
    class affiliation.")
    }
}

bicluster_pie <- function(bic, types, MARGIN = "column", named = TRUE) {
    attrs <- c()
    if (MARGIN == "column") {
        if (named) {
            attrs <- bic@colname
        } else {
            attrs <- bic@column
        }
    } else {
        if (named) {
            attrs <- bic@rowname
        } else {
            attrs <- bic@row
        }
    }
    tn <- names(types)
    types <- as.character(types)
    names(types) <- tn
    mapped <- types[attrs]
    if (any(is.na(mapped))) {
        stop("Problem in class_vector. Every element in a bicluster must have 
            an entry in the class_vector.")
    }
    num_attrs <- sort(unique(types))
    out <- rep(0, length(num_attrs))
    tmp <- table(mapped)

    for (i in seq(1, length(num_attrs))) {
        if (!is.na(tmp[num_attrs[i]])) {
            out[i] <- tmp[num_attrs[i]]
        }
    }

    return(out)
}

biclusters_pie <- function(bics, types, MARGIN = "column", named=TRUE) {
    tmp <- lapply(bics, bicluster_pie, types = types, MARGIN = MARGIN, 
                    named=named)
    check_pie(tmp)
    return(tmp)
}


#' Plot a bicluster network with piecharts as nodes.
#'
#' @param bic_net A \code{\link{bicluster_net}} object.
#' @param bics The corresponding list of biclusters from \code{bic_net}.
#' After calculating communities with \code{\link{get_louvain_communities}}
#' it is necessary to get the subset of biclusters
#' using \code{\link{select_biclusters_from_bicluster_network}}.
#' @param class_vector A (named) vector with class affinities. Every occuring
#' element in the biclustes must have a non NA value in this list.
#' @param colors Colors used for the classes. Must be a vector with colors in
#' the order of sort(unique(class_vector)).
#' @param named Indicates if \code{rowname}/\code{colname} of the bicluster
#' objects should be used instead of the indizes.
#' @param MARGIN Must be "row" or "column". Indicates which dimension of the
#' bicluster should be used for coloring.
#' @param new_layout If \code{FALSE}, the plot accepts a network layout as a
#' parameter, other wise a new layout is computed.
#' @param ... Additional parameters forwarded
#' to \code{\link[igraph]{plot.igraph}}.
#' @return If \code{new_layout}, a new network layout is returned that can
#' be used for other plots.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # groups <- ifelse(runif(100)< 0.5, "group1", "group2")
#' # cols <- c("group1"="blue", "group2"="grey")
#' # plot_piechart_bicluster_network(bn, bics, groups, cols, named=FALSE)
#' 
#' @export
plot_piechart_bicluster_network <- function(bic_net, bics, class_vector,
                                            colors, named = TRUE,
                                            MARGIN = "column",
                                            new_layout = TRUE, ...) {
    if (new_layout) {
        l <- igraph::layout_nicely(bicluster_net_to_igraph(bic_net))
        plot(bicluster_net_to_igraph(bic_net),
            layout = l, vertex.shape = "pie",
            vertex.pie = biclusters_pie(bics, class_vector, MARGIN = MARGIN, 
                                        named = named),
            vertex.pie.color = list(colors), ...
        )
        invisible(l)
    } else {
        plot(bicluster_net_to_igraph(bic_net),
            vertex.shape = "pie",
            vertex.pie = biclusters_pie(bics, class_vector, MARGIN = MARGIN, 
                                        named = named),
            vertex.pie.color = list(colors), ...
        )
    }
}


#' Plot a bicluster network colored by algorithms.
#'
#' In the plot each bicluster is colored by the algorithm, that generated it.
#'
#' @param bic_net A \code{\link{bicluster_net}} object.
#' @param bics The corresponding list of biclusters from \code{bic_net}.
#' @param new_layout If \code{FALSE}, the plot accepts a network layout as
#' a parameter, other wise a new layout is computed.
#' @param ... Plot parameters forwarded
#' to \code{igraph::\link[igraph]{plot.igraph}}
#' After calculating communities with \code{\link{get_louvain_communities}}
#' it is necessary to get the subset of biclusters
#' using \code{\link{select_biclusters_from_bicluster_network}}.
#' @return If \code{new_layout}, a new network layout is returned
#' that can be used for other plots.
#' @importFrom RColorBrewer brewer.pal
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # plot_algo_network(bn, bics)
#' 
#' @export
plot_algo_network <- function(bic_net, bics, new_layout = TRUE, ...) {
    algocolors <- c(
        "fabia" = "red",
        "isa2" = "green",
        "biclust-qubic" = "blue",
        "QUBIC2" = "darkblue",
        "biforce" = "grey",
        "biclustpy" = "white",
        "BicARE" = "magenta",
        "biclust-plaid" = "black",
        "biclust-quest" = "yellow",
        "biclust-spectral" = "pink",
        "biclust-bimax" = "brown",
        "biclust-cc" = "orange",
        "biclust-xmotifs" = "darkorange",
        "biclust-unibic" = "cyan"
    )

    algs <- unique(vapply(bics, function(x) {
        return(x@algorithm)
    }, ""))



    if (new_layout) {
        l <- igraph::layout_nicely(bicluster_net_to_igraph(bic_net))
        plot(bicluster_net_to_igraph(bic_net),
            vertex.color = algocolors[algohistogram(bics)], layout = l, ...
        )
        graphics::legend("topright",
            legend = names(algocolors[algs]),
            fill = algocolors[algs], title = "Algorithms", bg = "white"
        )
        invisible(l)
    } else {
        plot(bicluster_net_to_igraph(bic_net),
            vertex.color = algocolors[algohistogram(bics)], ...
        )
        graphics::legend("topright",
            legend = names(algocolors[algs]),
            fill = algocolors[algs], title = "Algorithms", bg = "white"
        )
    }
}

#' Node sizes for plotting bicluster networks.
#'
#' When plotting bicluster networks, node sizes adapted to bicluster sizes
#' can improve visual inspection.
#' Node sizes are computed using the following formula:
#' \code{(atan( (x - min(x)) / (max(x) - min(x)) + offset ) * base_size)}.
#' With x being defined a vector of bicluster sizes defined
#' by the \code{MARGIN} parameter.
#'
#' @param bics A list of \code{\link{bicluster}} objects.
#' @param base_size Is multiplied with the atan result for the node size
#' @param offset Offset for the atan calculation. Has to be > 0.
#' Smaller values result in higher differences of node sizes.
#' @param MARGIN "column", "row" or "both" are taken into account
#' for the size of a bicluster bicluster
#' @return Vector of node sizes as floats.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bn <- bicluster_network(bics, m)
#' # nz <- node_size(bics)
#' # plot_algo_network(bn, bics, vertex.size=nz)
#' # plot(bn, vertex.size=node_size(bics, offset=.1, base_size=15))
#' 
#' @export
node_size <- function(bics, base_size = 10, offset = .2, MARGIN = "column") {
    if (MARGIN == "column") {
        x <- colhistogram(bics)
    } else if (MARGIN == "row") {
        x <- rowhistogram(bics)
    } else {
        x <- rowhistogram(bics) * colhistogram(bics)
    }
    return(atan((x - min(x)) / (max(x) - min(x)) + offset) * base_size)
}

#' @include bicluster.R
NULL

NoBicARE <- function(bics) {
    return(dim(bics$bicCol)[1])
}

#' Extract a list of bicluster objects from an BicARE biclustering object.
#'
#' @param bics A BicARE bicluster object.
#' @param mat Original matrix, that was used for biclustering.
#' @param transposed \code{True}, if the bicluster calculation was
#' performed on a tranposed matrix.
#' @param filterfun A function to filter biclusters. Only if the
#' function returns \code{True}, the bicluster is added to the returned list.
#' The function has to accept a the bicluster (given as submatrix
#' of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.
#' @param ... Other parameters forwarded to the \code{filterfun}.
#' @return A list of \code{\link{bicluster}} objects, which have to
#' be valid (See \code{\link{validate_bicluster}}.
#' 
#' @examples
#' # Note that BicARE packackage is not included in the mosbi package
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # res <- BicARE::FLOC(m)
#' # getBicAREbiclusters(res, m)
#' 
#' @export
getBicAREbiclusters <- function(bics, mat,
                                transposed = FALSE,
                                filterfun = NULL, ...) {
    numClus <- NoBicARE(bics)

    tmp <- bicluster()
    res <- list()

    # BicARE returns boolean bicluster affiliation
    rows <- seq(1, (dim(bics$bicRow)[2]))
    cols <- seq(1, (dim(bics$bicCol)[2]))

    for (i in seq(1, numClus)) {

        # generate bicluster object
        if (transposed) {
            tmp <- bicluster(
                column = rows[as.logical(bics$bicRow[i, ])],
                row = cols[as.logical(bics$bicCol[i, ])],
                algorithm = "BicARE"
            )
        } else {
            tmp <- bicluster(
                row = rows[as.logical(bics$bicRow[i, ])],
                column = cols[as.logical(bics$bicCol[i, ])],
                algorithm = "BicARE"
            )
        }
        tmp <- set_bicluster_names(tmp, mat)
        # Check if cluster fits the constraints
        if (validate_bicluster(tmp)) {
            if (is.null(filterfun)) {
                res[[length(res) + 1]] <- tmp
            } else {
                if (filterfun(bicluster_to_matrix(mat, tmp), ...)) {
                    res[[length(res) + 1]] <- tmp
                }
            }
        }
    }

    return(res)
}

#' @include bicluster.R
NULL


#' Filter a matrix
#'
#' All values below the threshold will be replaces by 0.
#'
#' @param mat A Numeric matrix.
#' @param threshold All values below will be replaces by 0.
#' @return A filtered numeric matrix.
#' 
#' @examples
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # filter_matrix(m, threshold=1)
#'
#' @export
filter_matrix <- function(mat, threshold = 1) {
    tmp <- mat
    tmp[mat < threshold] <- 0
    return(tmp)
}

plot_error_model <- function(sn_ratio, org_edges, info_curve,
                            n_randomizations, tmp_l, threshold) {
    graphics::par(mfrow = c(1, 2))
    if (sn_ratio) {
        plot(org_edges[, 1], info_curve,
            xlab = "Threshold",
            ylab = "Signal to Noise ratio"
        )
        graphics::abline(v = threshold, col = "red", lty = 2)
    } else {
        plot(org_edges[, 1], info_curve,
            xlab = "Threshold",
            ylab = "Estimated fraction of false positives"
        )
        graphics::abline(v = threshold, col = "red", lty = 2)
    }

    plot(org_edges[, 1], org_edges[, 2] + 1,
        type = "l", col = "red",
        xlab = "Threshold", ylab = "Remaining edges", log = "y",
        main = "Threshold estimation"
    )
    graphics::legend(
        x = "topright",
        legend = c(
            "Org. network",
            "Randomizations", "Est. threshold"
        ),
        col = c("red", "black", "red"), lty = c(1, 1, 2)
    )
    for (j in seq(1, n_randomizations)) {
        graphics::lines(tmp_l[[j]])
    }
    graphics::abline(v = threshold, col = "red", lty = 2)

    graphics::par(mfrow = c(1, 1))
}

random_similarities <- function(n_randomizations, bics, mat, prob_scale, 
                                metric, prl, max_mat, MARGIN, n_steps){
    rand_sim <- 0
    tmp_l <- list()
    tmp_v <- c()
    for (i in seq(1, n_randomizations)) {
        tmp_sample <- sample_biclusters(bics, mat)
        if (MARGIN == "mean") {
            rand_sim_r <- similarity_matrix(tmp_sample,
                                            MARGIN = "row", metric,
                                            prob_scale = prob_scale,
                                            mat_row = nrow(mat), 
                                            mat_col = ncol(mat)
            )
            rand_sim_c <- similarity_matrix(tmp_sample,
                                            MARGIN = "column",
                                            metric, prob_scale = prob_scale,
                                            mat_row = nrow(mat), 
                                            mat_col = ncol(mat)
            )
            rand_sim <- (rand_sim_r + rand_sim_c) / 2
        } else {
            rand_sim <- similarity_matrix(tmp_sample, MARGIN, metric,
                                            prob_scale = prob_scale,
                                            mat_row = nrow(mat),
                                            mat_col = ncol(mat), prl = prl)}
        tmp <- network_edge_strength_float(rand_sim, n_steps, max_mat)
        tmp_l[[i]] <- tmp
        tmp_l[[i]][, 2] <- tmp_l[[i]][, 2] + 1
        tmp_v <- c(tmp_v, tmp[, 2])
    }
    
    return(list("tmp_l"=tmp_l, "tmp_v"=tmp_v))
}

org_similarity <- function(MARGIN, bics, metric, prob_scale, mat, prl){
    org_sim <- 0
    if (MARGIN == "mean") {
        org_sim_r <- similarity_matrix(bics,
                                        MARGIN = "row", metric,
                                        prob_scale = prob_scale,
                                        mat_row = nrow(mat), mat_col = ncol(mat))
        org_sim_c <- similarity_matrix(bics,
                                        MARGIN = "column",
                                        metric, prob_scale = prob_scale,
                                        mat_row = nrow(mat), mat_col = ncol(mat))
        org_sim <- (org_sim_r + org_sim_c) / 2
    } else {
        org_sim <- similarity_matrix(bics, MARGIN, metric,
                                        prob_scale = prob_scale,
                                        mat_row = nrow(mat), 
                                        mat_col = ncol(mat),
                                        prl = prl)}
    
    return(org_sim)
}


#' Generate a bicluster network
#'
#' The function computes a bicluster network based on a selected
#' similarity metric.
#' A similarity cut-off is calculated using randomized
#' biclusters (the bicluster size distribution is kept).
#'
#' @param bics A list of bicluster objects.
#' @param mat The matrix used for biclustering.
#' @param n_randomizations The number of randomizations for
#' cut-off estimation. (The mean of all randomizations is used).
#' @param MARGIN Margin over which the similarity is computed.
#' Can be "row", "column", "mean" (In this case the mean of
#' row and column similarity is used) or "both" (In this case
#' the similarity between all the datapoints of biclusters is used).
#' @param metric The similarity metric same as
#' in \code{\link{similarity_matrix}}.
#' @param n_steps Number of points where the difference
#' between randomizations and the real data is evaluated.
#' @param plot_edge_dist Show the plots for cut-off estimation
#' with the error model.
#' @param sn_ratio If \code{TRUE}, the signal to noise ratio is
#' computed, otherwise the \code{error_threshold} is used to to
#' estimate the cut-off at which only \code{error_threshold*100}
#' percent of the edges are estimated to be random overlaps.
#' @param error_threshold If \code{sn_ratio==FALSE} this threshold
#' is used to estimate the threshold at which
#' only \code{error_threshold*100} percent of the edges are
#' estimated to be random overlaps.
#' @param prob_scale Scale similarity by the probability of an
#' overlap equal of higher to the observed one. The scaling is
#' done by multiplying the similarity
#' with \code{(1 - (1 / (1 - log(overlap_probability, base=100))))}.
#' The probability is computed using the f
#' unction \code{\link{p_overlap_2d_higher}}
#' for \code{MARGIN =="both"} and  \code{\link{p_overlap_higher}}
#' otherwise. Can be helpful for big imbalances of bicluster sizes.
#' @param return_plot_data Please do not use outside of the package.
#' @param prl Compute the similarity matrix using multiple
#' cores (works only for \code{MARGIN="both"}). The number of core can be
#' defined by executing: \code{RcppParallel::setThreadOptions(numThreads = 4)}
#' before running this function.
#'
#' @return An object of class \code{\link{bicluster_net}}.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # bicluster_network(bics, m)
#'
#' @export
bicluster_network <- function(bics, mat, n_randomizations = 5, MARGIN = "both",
                            metric = 4, n_steps = 100, plot_edge_dist = TRUE,
                            sn_ratio = TRUE,
                            error_threshold = .05, return_plot_data = FALSE,
                            prob_scale = FALSE, prl = FALSE) {
    if (n_randomizations < 1) { stop("Parameter n_randomization must be >= 1.")}
    # Original similarity
    org_sim <- org_similarity(MARGIN, bics, metric, prob_scale, mat, prl)
    org_edges <- network_edge_strength_float(org_sim, n_steps)
    max_mat <- max(org_sim)
    steps <- dim(org_edges)[1]
    # Random similarities
    tmp = random_similarities(n_randomizations, bics, mat, prob_scale, 
                                metric, prl, max_mat, MARGIN, n_steps)
    tmp_l = tmp[["tmp_l"]]
    tmp_v = tmp[["tmp_v"]]
    sample_mat <- matrix(tmp_v, nrow = steps)
    # Average Edge count
    mean_random_edges <- apply(sample_mat, 1, mean)
    threshold <- 0
    info_curve <- c()
    if (sn_ratio) {
        info_curve <- (org_edges[, 2] + 1) / (mean_random_edges + 1)
        threshold <- org_edges[which.max(info_curve), 1]
    } else {
        info_curve <- mean_random_edges / org_edges[, 2]
        if (min(info_curve) > error_threshold) {
            error_threshold <- min(info_curve)
            warning("Threshold cannot be reached replaced by minimum value: ",
                round(error_threshold, 4))}
        tmp_t <- min((
            seq(1, length(mean_random_edges)))[info_curve <= error_threshold])
        threshold <- org_edges[tmp_t, 1]
    }
    cat("Esimated cut-off: ", threshold, "\n")
    # Remaining edges Plot
    if (plot_edge_dist) {
        plot_error_model(sn_ratio, org_edges, info_curve, n_randomizations,
            tmp_l, threshold)}
    algs <- get_algorithms(bics)
    if (return_plot_data) {
        return(list(
            bicluster_net(adjacency_matrix = org_sim, threshold = threshold, 
                        algorithms = algs),
            list(sn_ratio, org_edges, info_curve,
                n_randomizations, tmp_l, threshold)))
    } else {
        return(bicluster_net(adjacency_matrix = org_sim,
            threshold = threshold, algorithms = algs))}}




random_f_similarities <- function(bics, mat, n_randomizations, rr, rc, cc, w, 
                                    n_steps, max_mat){
    tmp_l <- list()
    tmp_v <- c()
    # Random similarities
    for (i in seq(1, n_randomizations)) {
        tmp_sample <- sample_biclusters(bics, mat)
        rand_sim <- full_graph(tmp_sample, mat,
                                rr_weight = rr, rc_weight = rc,
                                cc_weight = cc, weighting = w)
        tmp <- network_edge_strength_float(rand_sim, n_steps, max_mat)
        tmp_l[[i]] <- tmp
        tmp_v <- c(tmp_v, tmp[, 2])
    }
    
    return(list("tmp_l"=tmp_l, "tmp_v"=tmp_v))
}

#' Generate a co-occurence network
#'
#' The function computes a co-occurence network, based on the
#' function \code{\link{full_graph}}.
#' A similarity threshold is calculated using randomized
#' biclusters (the bicluster size distribution is kept).
#'
#' @param bics A list of bicluster objects.
#' @param mat The matrix used for biclustering.
#' @param n_randomizations The number of randomizations for cut-off
#' estimation. (The mean of all randomizations is used).
#' @param n_steps Number of points where the difference between
#' randomizations and the real data is evaluated.
#' @param plot_edge_dist Show the plots for threshold estimation.
#' @param sn_ratio If \code{TRUE}, the signal to noise ratio is
#' computed, otherwise the \code{error_threshold} is used to to
#' estimate the threshold at which only \code{error_threshold*100} percent
#' of the edges are estimated to be random overlaps.
#' @param error_threshold If \code{sn_ratio==FALSE} this cut-off is
#' used to estimate the cut-off at which only \code{error_threshold*100}
#' percent of the edges are estimated to be random overlaps.
#' @param return_plot_data Please do not use outside of the package.
#' @param rr See \code{\link{full_graph}}.
#' @param rc See \code{\link{full_graph}}.
#' @param cc See \code{\link{full_graph}}.
#' @param w See parameter weighting of \code{\link{full_graph}}.
#'
#' @return An object of class \code{\link{cooccurrence_net}}.
#' 
#' @examples 
#' m <- matrix(seq(1:16), nrow=4)
#' # m <- matrix(rnorm(10000), nrow=100)
#' # bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
#' # feature_network(bics, m)
#'
#' @export
feature_network <- function(bics, mat, n_randomizations = 5, n_steps = 100,
                            plot_edge_dist = TRUE, sn_ratio = 1,
                            error_threshold = .05,
                            return_plot_data = FALSE, rr = 1.,
                            rc = 1., cc = 1., w = 0) {
    if (n_randomizations < 1) {stop("Parameter n_randomization must be >= 1.")}
    org_sim <- 0
    rand_sim <- 0
    org_sim <- full_graph(bics, mat, rr_weight = rr,
        rc_weight = rc, cc_weight = cc, weighting = w)
    org_edges <- network_edge_strength_float(org_sim, n_steps)
    max_mat <- max(org_sim)
    steps <- dim(org_edges)[1]
    tmp <- random_f_similarities(bics, mat, n_randomizations, rr, rc, cc, w, 
                                n_steps, 
                                max_mat)
    tmp_l = tmp[["tmp_l"]]
    tmp_v = tmp[["tmp_v"]]
    sample_mat <- matrix(tmp_v, nrow = steps)
    mean_random_edges <- apply(sample_mat, 1, mean)
    threshold <- 0
    info_curve <- c()
    if (sn_ratio) {
        info_curve <- org_edges[, 2] / mean_random_edges
        threshold <- org_edges[which.max(info_curve), 1]
    } else {
        info_curve <- mean_random_edges / org_edges[, 2]
        if (min(info_curve) > error_threshold) {
            error_threshold <- min(info_curve)
            warning("Threshold cannot be reached, replaced by minimum value: ",
                round(error_threshold, 4))}
        tmp_t <- min((
            seq(1, length(mean_random_edges)))[info_curve <= error_threshold])
        threshold <- org_edges[tmp_t, 1]}
    cat("Esimated cut-off: ", threshold, "\n")
    if (plot_edge_dist) {
        plot_error_model(sn_ratio, org_edges, info_curve,
            n_randomizations, tmp_l, threshold)}
    if (return_plot_data) {
        return(list(cooccurrence_net(
                adjacency_matrix = org_sim,
                threshold = threshold),
            list(sn_ratio, org_edges, info_curve,
                n_randomizations, tmp_l, threshold)))
    } else {
        return(cooccurrence_net(
            adjacency_matrix = org_sim,
            threshold = threshold))}}

#' Filter biclusters based on a user defined filter function.
#' 
#' If the function returns \code{True}, the bicluster is added to the output
#' list of biclusters.
#' Every bicluster is validated, before forwarding to the filter-function.
#'
#' @param bics A list of valid bicluster objects.
#' @param mat Original matrix, that was used for biclustering.
#' @param filterfun A function to filter biclusters. Only if the function
#' returns \code{True}, the bicluster is added to the returned list.
#' The function has to accept a the bicluster (given as submatrix
#' of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.
#' @param ... Other parameters forwarded to the \code{filterfun}.
#' @return A filtered list ob bicluster objects with
#' length(returned_list)<=length(bics).
#' 
#' @examples
#' # m <- matrix(runif(100), nrow=10)
#' b <- list(bicluster(row=c(3,4), column=c(3,4)),
#'     bicluster(row=c(3,4,5,6), column=c(3,4,5,6)),
#'     bicluster(row=c(3,4,5,6), column=c(3,6)))
#' # filter_biclusters(b, m, function(x) sum(x) < 0)
#'
#' @export
filter_biclusters <- function(bics, mat, filterfun, ...) {
    out_list <- list()
    for (i in seq(1, length(bics))) {
        if (validate_bicluster(bics[[i]])) {
            if (filterfun(bicluster_to_matrix(mat, bics[[i]]), ...)) {
                out_list[[length(out_list) + 1]] <- bics[[i]]
            }
        }
    }

    return(out_list)
}

---
title: "Similarity Metrics Evaluation"
author: "Tim Daniel Rose"
date: "`r Sys.Date()`"
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{similarity-metrics-evaluation}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.width = 7,
    fig.height = 7
)
```

In the `mosbi` package, similarities between biclusters are 
computed using different possible similarity metrics.

This vignette gives an overview about the implemented metrics.

```{r setup}
library(mosbi)
```


The following similarity metrics are currently implemented:

* Bray-Curtis similarity 
([Wikipedia](https://en.wikipedia.org/wiki/Bray%E2%80%93Curtis_dissimilarity))

* Jaccard index 
([Wikipedia](https://en.wikipedia.org/wiki/Jaccard_index))

* overlap coefficient 
([Wikipedia](https://en.wikipedia.org/wiki/Overlap_coefficient))

* Fowlkes–Mallows index 
([Wikipedia](https://en.wikipedia.org/wiki/Fowlkes%E2%80%93Mallows_index))

```{r}
# Bray-Curtis similarity
bray_curtis <- function(s1, s2, overlap) {
    return(((2 * overlap) / (s1 + s2)))
}

# Jaccard index
jaccard <- function(s1, s2, overlap) {
    return(((overlap) / (s1 + s2 - overlap)))
}

# overlap coefficient
overlap <- function(s1, s2, overlap) {
    return((overlap / min(s1, s2)))
}

# Fowlkes–Mallows index
folkes_mallows <- function(s1, s2, overlap) {
    tp <- choose(overlap, 2)
    fp <- choose(s1 - overlap, 2)
    fn <- choose(s2 - overlap, 2)

    return(sqrt((tp / (tp + fp)) * (tp / (tp + fn))))
}
```


The behavior of the similarity metrics will be evaluated for two scenarios:

* Two biclusters of the same size with an increasing overlap.

* Two biclusters of different sizes (One twice as big as the other) 
with an increasing overlap.

```{r}
# Scenario 1 - two biclusters of the same size
size1_1 <- rep(1000, 1000)
size2_1 <- rep(1000, 1000)
overlap_1 <- seq(1, 1000)

# Scenario 2 - two biclusters one of size 500, the other of size 1000
size1_2 <- rep(1000, 500)
size2_2 <- rep(500, 500)
overlap_2 <- seq(1, 500)
```


Two biclusters of the same size:
```{r}
plot(overlap_1, bray_curtis(size1_1, size2_1, overlap_1),
    col = "red", type = "l", xlab = "Overlap", ylab = "Similarity", 
    ylim = c(0, 1)
)
lines(overlap_1, jaccard(size1_1, size2_1, overlap_1), col = "blue")
lines(overlap_1, overlap(size1_1, size2_1, overlap_1), col = "green", lty = 2)
lines(overlap_1, folkes_mallows(size1_1, size2_1, overlap_1), col = "orange")
legend(
    x = .8, legend = c("Bray-Curtis", "Jaccard", "Overlap", "Fowlkes–Mallows"),
    col = c("red", "blue", "green", "orange"),
    lty = 1, cex = 0.8, title = "Similarity metrics"
)
```

Two biclusters of different sizes:
```{r}
plot(overlap_2, bray_curtis(size1_2, size2_2, overlap_2),
    col = "red", type = "l", xlab = "Overlap", ylab = "Similarity", 
    ylim = c(0, 1)
)
lines(overlap_2, jaccard(size1_2, size2_2, overlap_2), col = "blue")
lines(overlap_2, overlap(size1_2, size2_2, overlap_2), col = "green")
lines(overlap_2, folkes_mallows(size1_2, size2_2, overlap_2), col = "orange")
legend(
    x = .8, legend = c("Bray-Curtis", "Jaccard", "Overlap", "Fowlkes–Mallows"),
    col = c("red", "blue", "green", "orange"),
    lty = 1, cex = 0.8, title = "Similarity metrics"
)
```


# Session Info
```{r}
sessionInfo()
```

---
title: "Example workflow"
author: "Tim Daniel Rose"
date: "`r Sys.Date()`"
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{example-workflow}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
```

This vignette shows an example workflow for ensemble biclustering analysis 
with the `mosbi` package.
Every function of the package has a help page with a detailed documentation. 
To access these type `help(package=mosbi)` in the `R` console.

### Load packages

Import dependencies.
```{r setup, message=FALSE}
library(mosbi)
```

### Helper functions

Two additional functions are defined, to calculate z-scores of the data and 
to visualize the biclusters as a histogram.
```{r}
z_score <- function(x, margin = 2) {
    z_fun <- function(y) {
        (y - mean(y, na.rm = TRUE)) / sd(y, na.rm = TRUE)
    }

    if (margin == 2) {
        return(apply(x, margin, z_fun))
    } else if (margin == 1) {
        return(t(apply(x, margin, z_fun)))
    }
}

bicluster_histo <- function(biclusters) {
    cols <- mosbi::colhistogram(biclusters)
    rows <- mosbi::rowhistogram(biclusters)

    graphics::par(mfrow = c(1, 2))
    hist(cols, main = "Column size ditribution")
    hist(rows, main = "Row size ditribution")
}
```
 

### 1. Download and prepare data

Biclustering will be done on a data matrix. As an example,  
lipidomics dataset from the metabolights database will be used 
`https://www.ebi.ac.uk/metabolights/MTBLS562`. 
The data consists of 40 samples (columns) and 245 lipids (rows).
```{r, message=FALSE}
# get data
data(mouse_data)

mouse_data <- mouse_data[c(
    grep(
        "metabolite_identification",
        colnames(mouse_data)
    ),
    grep("^X", colnames(mouse_data))
)]

# Make data matrix
data_matrix <- z_score(log2(as.matrix(mouse_data[2:ncol(mouse_data)])), 1)

rownames(data_matrix) <- mouse_data$metabolite_identification

stats::heatmap(data_matrix)
```
The data has a gaussian-like distribution and no missing values, 
so we can proceed with biclustering.

### 2. Compute biclusters

The `mosbi` package is able to work with results of different 
biclustering algorithms. The  approach unites the results 
from different algorithms.
The results of four example algorithms will be computed and 
converted to `mosbi::bicluster` objects. For a list of all 
supported biclustering algorithms/packages type `?mosbi::get_biclusters` 
in the `R` console.
```{r, message=FALSE}
# Fabia
fb <- mosbi::run_fabia(data_matrix) # In case the algorithms throws an error,
# return an empty list

# isa2
BCisa <- mosbi::run_isa(data_matrix)

# Plaid
BCplaid <- mosbi::run_plaid(data_matrix)

# QUBIC
BCqubic <- mosbi::run_qubic(data_matrix)

# Merge results of all algorithms
all_bics <- c(fb, BCisa, BCplaid, BCqubic)

bicluster_histo(all_bics)
```
The histogram visualizes the distribution of bicluster sizes 
(separately for the number of rows and columns of each bicluster). 
The total number of found biclusters are given in the title.

### 3. Compute network

The next step of the ensemble approach is the computation of a 
similarity network of biclusters. To filter for for similarities due to 
random overlaps of biclusters, we apply an error 
model (For more details refer to our publication). 
Different similarity metrics are available. 
For details type `mosbi::bicluster_network` in the `R` console.
```{r}
bic_net <- mosbi::bicluster_network(all_bics, # List of biclusters
    data_matrix, # Data matrix
    n_randomizations = 5,
    # Number of randomizations for the
    # error model
    MARGIN = "both",
    # Use datapoints for metric evaluation
    metric = 4, # Fowlkes–Mallows index
    # For information about the metrics,
    # visit the "Similarity metrics
    # evaluation" vignette
    n_steps = 1000,
    # At how many steps should
    # the cut-of is evaluated
    plot_edge_dist = TRUE
    # Plot the evaluation of cut-off estimation
)
```
The two resulting plot visualize the process of cut-off estimation. 
The right plot show the remaining number of edges for the computed 
bicluster network (red) and for randomizations of biclusters (black). 
The vertical red line showed the threshold with the highest 
signal-to-noise ratio (SNR). All evaluated SNRs are again 
visualized in the left plot. 


The next plot shows the bicluster similarity matrix. 
It reveals highly similar biclusters.
```{r}
stats::heatmap(get_adjacency(bic_net))
```

#### Visualize network

Before the final step, extraction of bicluster 
communities (ensemble biclusters), the bicluster 
network can be layouted as a network.
```{r}
plot(bic_net)
```
The networks are plotted using the `igraph` package. `igraph` 
specific plotting parameters can be added.
For help type: `?igraph::plot.igraph`

To see, which bicluster was generated by which algorithm, 
the following function can be executed:
```{r}
mosbi::plot_algo_network(bic_net, all_bics, vertex.label = NA)
```


The downloaded data contains samples from different weeks of 
development. This can be visualized on the network, showing 
from which week the samples within a bicluster come from.
```{r}
# Prepare groups for plotting
weeks <- vapply(
    strsplit(colnames(data_matrix), "\\."),
    function(x) {
        return(x[1])
    }, ""
)

names(weeks) <- colnames(data_matrix)

print(sort(unique(weeks))) # 5 colors required

week_cols <- c("yellow", "orange", "red", "green", "brown")

# Plot network colored by week
mosbi::plot_piechart_bicluster_network(bic_net, all_bics, weeks,
    week_cols,
    vertex.label = NA
)
graphics::legend("topright",
    legend = sort(unique(weeks)),
    fill = week_cols, title = "Week"
)
```

Such a visualization is also possible for the samples:
```{r}
# Prepare groups for plotting
samples <- vapply(
    strsplit(colnames(data_matrix), "\\."),
    function(x) {
        return(x[2])
    }, ""
)

names(samples) <- colnames(data_matrix)

samples_cols <- RColorBrewer::brewer.pal(
    n = length(sort(unique(samples))),
    name = "Set3"
)


# Plot network colored by week
mosbi::plot_piechart_bicluster_network(bic_net, all_bics, samples,
    samples_cols,
    vertex.label = NA
)
graphics::legend("topright",
    legend = sort(unique(samples)),
    fill = samples_cols, title = "Sample"
)
```

### 4. Extract louvain communities

Calculate the communities
```{r}
coms <- mosbi::get_louvain_communities(bic_net,
    min_size = 3,
    bics = all_bics
)
# Only communities with a minimum size of 3 biclusters are saved.
```


#### Visualization of the communities
```{r}
# Plot all communities
for (i in seq(1, length(coms))) {
    tmp_bics <- mosbi::select_biclusters_from_bicluster_network(
        coms[[i]],
        all_bics
    )

    mosbi::plot_piechart_bicluster_network(coms[[i]], tmp_bics,
        weeks, week_cols,
        main = paste0("Community ", i)
    )
    graphics::legend("topright",
        legend = sort(unique(weeks)),
        fill = week_cols, title = "Week"
    )

    cat("\nCommunity ", i, " conists of results from the
             following algorithms:\n")
    cat(get_bic_net_algorithms(coms[[i]]))
    cat("\n")
}
```

#### Extraction of the communities

Finally, communities of the network can be extracted as ensemble biclusters. 
The are saved as a list of `mosbi::bicluster` objects and therefore in the 
same format as the imported results of all the algorithms. 
With the parameters `row_threshold` & `col_threshold`, 
the minimum occurrence of a row- or column-element in the biclusters 
of a community can be defined.
```{r}
ensemble_bicluster_list <- mosbi::ensemble_biclusters(coms, all_bics,
    data_matrix,
    row_threshold = .1,
    col_threshold = .1
)
```


# Session Info
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{similarity_matrix}
\alias{similarity_matrix}
\title{Compute similarities between biclusters}
\usage{
similarity_matrix(
  bics,
  MARGIN = "both",
  metric = 1L,
  prob_scale = FALSE,
  mat_row = 0L,
  mat_col = 0L,
  prl = FALSE
)
}
\arguments{
\item{bics}{A list of bicluster objects.}

\item{MARGIN}{Choose if the distance is computed over \code{"row"}
, \code{"column"} or \code{"both"}.}

\item{metric}{Integer indicating which metric is used. 
1: Bray-Curtis similarity (default), 2: Jaccard index, 
3: overlap coefficient, 4: Fowlkes–Mallows index.}

\item{prob_scale}{Scale similarity by the probability of an 
overlap equal of higher to the observed one. The scaling is 
done by multiplying the similarity 
with \code{(1 - (1 / (1 - log(overlap_probability, base=100))))}. 
The probability is comupted using the 
function \code{\link{p_overlap_2d_higher}} 
for \code{MARGIN =="both"} and  \code{\link{p_overlap_higher}} 
otherwise. Can be helpful for big imbalances of bicluster sizes.}

\item{mat_row}{If \code{prob_scale == TRUE}, the number of rows of the 
input matrix for biclustering must be given.}

\item{mat_col}{If \code{prob_scale == TRUE}, the number of columns of 
the input matrix for biclustering must be given.}

\item{prl}{Compute the similarity matrix using multiple 
cores (works only for \code{MARGIN="both"}). The number of 
core can be defined by 
executing: \code{RcppParallel::setThreadOptions(numThreads = 4)} 
before running this function.}
}
\value{
A numeric matrix of the similarities between all given biclusters.
}
\description{
This function computes a similarity matrix between biclusters using
different similarity metrics.
}
\examples{
b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
        bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
similarity_matrix(b)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{plot,bicluster_net,missing-method}
\alias{plot,bicluster_net,missing-method}
\title{Plot a bicluster network}
\usage{
\S4method{plot}{bicluster_net,missing}(x, y, ...)
}
\arguments{
\item{x}{An object of class \code{\link{bicluster_net}}.}

\item{y}{Not used.}

\item{...}{Plot parameters forwarded
to \code{igraph::\link[igraph]{plot.igraph}}}
}
\value{
An \link[igraph]{graph} plot.
}
\description{
Converts the object into a \link[igraph]{graph} and uses its plot function.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# plot(bn)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{attribute_graph}
\alias{attribute_graph}
\title{Generate attribute specific co-occurance networks.}
\usage{
attribute_graph(bics, m, MARGIN = "column")
}
\arguments{
\item{bics}{A list of \code{\link{bicluster}}s.}

\item{m}{The matrix used for biclustering.}

\item{MARGIN}{\code{"row"} or \code{"row"}, Indicating if a list of 
row- or column-specific networks is generated}
}
\value{
A list of numeric matrices.
If \code{MARGIN="column"} (\code{"row"}), the list has a 
length of \code{ncol(m)} (\code{nrow(m)}) 
and each matrix the dimensions of \code{c(nrow(m), 
nrow(m))} (\code{c(ncol(m), ncol(m))})
}
\description{
The function generates co-occurance networks for all the attributes.
E.g. if \code{MARGIN="column"}, for each column, a oc-occurance matrix 
of rows is generated, which includes all biclusters, where the 
column element is present.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# attribute_graph(bics, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{attr_overlap}
\alias{attr_overlap}
\title{Count how often row/column elements occur in biclusters.}
\usage{
attr_overlap(bics, named)
}
\arguments{
\item{bics}{A list of \code{\link{bicluster}} objects.}

\item{named}{Boolean, indicating, if all bicluster objects have names.}
}
\value{
A Data Frame with the counts oof all elements.
}
\description{
Given a list of bicluster objects (\code{\link{bicluster}}), 
the function counts the occurance of all elements in the biclusters.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# attr_overlap(bics, named=FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{validate_bicluster}
\alias{validate_bicluster}
\title{Indicates, whether a bicluster is valid.
That means it needs at least one row and one column.}
\usage{
validate_bicluster(bic, minRow = 1L, minCol = 1L)
}
\arguments{
\item{bic}{A bicluster object}

\item{minRow}{Minimum number of required rows (Min=1).}

\item{minCol}{Minimum number of required columns (Min=1).}
}
\value{
Logical indicating a valid bicluster object.
}
\description{
Indicates, whether a bicluster is valid.
That means it needs at least one row and one column.
}
\examples{
validate_bicluster(bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{cpp_matrix_subsetting}
\alias{cpp_matrix_subsetting}
\title{Subsetting of R matrices within c++.}
\usage{
cpp_matrix_subsetting(m, bic)
}
\arguments{
\item{m}{A numeric matrix}

\item{bic}{A bicluster object.}
}
\value{
Matrix subset.
}
\description{
Subsetting of R matrices within c++.
}
\examples{
cpp_matrix_subsetting(matrix(seq(1:16), nrow=4), 
    bicluster(row=c(1,2), column=c(1,2)))
    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{plot_piechart_bicluster_network}
\alias{plot_piechart_bicluster_network}
\title{Plot a bicluster network with piecharts as nodes.}
\usage{
plot_piechart_bicluster_network(
  bic_net,
  bics,
  class_vector,
  colors,
  named = TRUE,
  MARGIN = "column",
  new_layout = TRUE,
  ...
)
}
\arguments{
\item{bic_net}{A \code{\link{bicluster_net}} object.}

\item{bics}{The corresponding list of biclusters from \code{bic_net}.
After calculating communities with \code{\link{get_louvain_communities}}
it is necessary to get the subset of biclusters
using \code{\link{select_biclusters_from_bicluster_network}}.}

\item{class_vector}{A (named) vector with class affinities. Every occuring
element in the biclustes must have a non NA value in this list.}

\item{colors}{Colors used for the classes. Must be a vector with colors in
the order of sort(unique(class_vector)).}

\item{named}{Indicates if \code{rowname}/\code{colname} of the bicluster
objects should be used instead of the indizes.}

\item{MARGIN}{Must be "row" or "column". Indicates which dimension of the
bicluster should be used for coloring.}

\item{new_layout}{If \code{FALSE}, the plot accepts a network layout as a
parameter, other wise a new layout is computed.}

\item{...}{Additional parameters forwarded
to \code{\link[igraph]{plot.igraph}}.}
}
\value{
If \code{new_layout}, a new network layout is returned that can
be used for other plots.
}
\description{
Plot a bicluster network with piecharts as nodes.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# groups <- ifelse(runif(100)< 0.5, "group1", "group2")
# cols <- c("group1"="blue", "group2"="grey")
# plot_piechart_bicluster_network(bn, bics, groups, cols, named=FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ensemble_bicluster.R
\name{ensemble_biclusters}
\alias{ensemble_biclusters}
\title{Convert communities into ensemble biclusters}
\usage{
ensemble_biclusters(
  coms,
  bics,
  mat,
  row_threshold = 0.1,
  col_threshold = 0.1,
  threshold_sorted = FALSE
)
}
\arguments{
\item{coms}{A list of communities (\code{\link{bicluster_net}}s) as
outputted by \code{\link{get_louvain_communities}}.}

\item{bics}{The list biclusters that was used for calculation
with \code{\link{bicluster_network}}.}

\item{mat}{The numeric matrix, that was used for biclustering.}

\item{row_threshold}{Minimum fraction of biclusters of a community
in which a row needs to occur so that it will be part of the
outputted ensemble bicluster.}

\item{col_threshold}{Minimum fraction of biclusters of a community
in which a column needs to occur so that it will be part of the
outputted ensemble bicluster.}

\item{threshold_sorted}{Return the rows and columns in sorted by
decreasing fraction.}
}
\value{
A list of \code{\link{bicluster}} objects.
}
\description{
After calculation of communities with
the \code{\link{get_louvain_communities}} function, the result can be
converted into a list of \code{\link{bicluster}} objects with this function.
Only biclusters are returned which have a minimum dimension of 2x2.
}
\examples{
b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
    bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
# m <- matrix(runif(100), nrow=10)
# tm = matrix(c(0,1,1,0), nrow=2)
# bn <- list(bicluster_net(adjacency_matrix=tm, threshold=.5))
# ensemble_biclusters(bn, b, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{has_names}
\alias{has_names}
\title{Check, whether a matrix has row- and colnames.}
\usage{
has_names(m)
}
\arguments{
\item{m}{A matrix}
}
\value{
Logical indicating existence of row- and colnames.
}
\description{
Check, whether a matrix has row- and colnames.
}
\examples{
has_names(matrix(c(1,2,3,4), nrow=2))

m <- matrix(c(1,2,3,4), nrow=2)
rownames(m) <- c("r1", "r2")
rownames(m) <- c("c1", "c2")
has_names(m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{is_subset_or_identical}
\alias{is_subset_or_identical}
\title{Check if a bicluster is a subset (in rows AND columns) 
of identical to another bicluster.}
\usage{
is_subset_or_identical(bic1, bic2)
}
\arguments{
\item{bic1}{A bicluster.}

\item{bic2}{A bicluster.}
}
\value{
1 if bic1 is a subset of bic2, 2 if bic 1 is 
identical to bic2, 0 else.
}
\description{
Check if a bicluster is a subset (in rows AND columns) 
of identical to another bicluster.
}
\examples{
is_subset_or_identical(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
    bicluster(row=c(1,2,3,4), column=c(1,2,3,4)))
    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{getBFCluster}
\alias{getBFCluster}
\title{Get a bicluster a Bi-Force output file}
\usage{
getBFCluster(filename, cluster)
}
\arguments{
\item{filename}{Name of the Bi-Force output file.}

\item{cluster}{Number of the bicluster that should be extracted.}
}
\value{
Bicluster as list with rownames in attribute "row" 
and colnames in attribute "column".
}
\description{
Get a bicluster a Bi-Force output file
}
\examples{
a <- "PathToBiForceOutput.txt"
# getBFCluster(a, cluster=1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{attributeConnector}
\alias{attributeConnector}
\title{Extract the class-wise degree of an adjacency matrix.}
\usage{
attributeConnector(mat, otherclasses, useOther = FALSE)
}
\arguments{
\item{mat}{A adjacency matrix with bipartite interactions as 
computed by \code{\link{full_graph}} or \code{\link{attribute_graph}} 
(with parameter \code{bipartite=TRUE}).}

\item{otherclasses}{A logical vector indicating two classes 
of elements in rows (columns).}

\item{useOther}{Logical indicating if the attributes, that 
are classified appear first in the matrix (\code{True}) or 
the attributes that connect classified attributes (\code{False}).}
}
\value{
A DataFrame that holds the total degree of every 
attribute (row/column) and the fraction of the degree that 
connects only to elements of class \code{True} (from 
parameter \code{otherclasses}).
}
\description{
For a adjacency matrix as computed by \code{\link{full_graph}},
the function computes how many row-column interactions connect 
rows (columns) to columns (rows) of a specific class/category.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# fn <- feature_network(bics, m)
# attributeConnector(apply_threshold(fn), 
#     otherclasses=c(rep(FALSE, 100), rep(TRUE, 100)))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/feature_louvain_overlap.R
\name{feature_louvain_overlap}
\alias{feature_louvain_overlap}
\title{Overlap of features/samples in different louvain communities}
\usage{
feature_louvain_overlap(overlap_tables, mat)
}
\arguments{
\item{overlap_tables}{List of tables as returned by \code{\link{attr_overlap}}.}

\item{mat}{The data matrix used as input for the biclustering algorithms.}
}
\value{
List of tables as returned by \code{\link{attr_overlap}}, 
extended by a column showing how often elements occur across all tables.
}
\description{
The function calculates how often features or samples occur across 
all calculated louvain communities
}
\examples{
# a = data.frame(type=c("row", "row", "row", "column", "column", "column"), 
#   ID=c(1,2,3,1,2,3), Fraction=c(1,1,1,.5, .5, .5))
# b = data.frame(type=c("row", "row", "row", "column", "column", "column"), 
#   ID=c(3,2,4,1,5,3), Fraction=c(1,1,1,.5, .5, .5))
# inl <- list(a, b)
# feature_louvain_overlap(outl, matrix(1:100, nrow=10))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{check_names}
\alias{check_names}
\title{Throw an error, if a matrix has not both row- and colnames.}
\usage{
check_names(m)
}
\arguments{
\item{m}{A matrix.}
}
\value{
Throws error, if matrix has no row- and column names.
}
\description{
Throw an error, if a matrix has not both row- and colnames.
}
\examples{
m <- matrix(c(1,2,3,4), nrow=2)
rownames(m) <- c("r1", "r2")
colnames(m) <- c("c1", "c2")
check_names(m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_algorithms.R
\name{run_fabia}
\alias{run_fabia}
\title{Run the fabia biclustering algorithm}
\usage{
run_fabia(
  data_matrix,
  minRow = 2,
  minCol = 2,
  thresZ = 0.5,
  thresL = NULL,
  ...
)
}
\arguments{
\item{data_matrix}{A numeric matrix.}

\item{minRow}{Same parameters as in \link{filter_bicluster_size}.}

\item{minCol}{Same parameters as in \link{filter_bicluster_size}.}

\item{thresZ}{See parameter from the \link[fabia]{extractBic} function.}

\item{thresL}{See parameter from the \link[fabia]{extractBic} function.}

\item{...}{Other parameters forwarded to the \link[fabia]{fabia} function.}
}
\value{
a list of \link{bicluster} objects.
}
\description{
The function executes the \link[fabia]{fabia} biclustering algorithm,
returning a list of biclusters converted into bicluster objects
compatible with this package.
If the algorithm fails to run, an empty list is returned.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(1000), nrow=10)
# run_fabia(m, p=5)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mouse_data.R
\docType{data}
\name{mouse_data}
\alias{mouse_data}
\title{Mouse brain lipidomics data}
\format{
A data frame with 245 rows and 61 columns
}
\source{
\url{https://www.ebi.ac.uk/metabolights/MTBLS562}
}
\usage{
data(mouse_data)
}
\description{
Development of the mice brain lipidome over several weeks.
}
\examples{
# data(mouse_data)
# View(mouse_data)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{replace_threshold}
\alias{replace_threshold}
\title{Replace elements of an integer matrix.}
\usage{
replace_threshold(m, threshold)
}
\arguments{
\item{m}{A numeric matrix.}

\item{threshold}{A numeric threshold under which all elements in the 
matrix are replaced by zero.}
}
\value{
An integer matrix.
}
\description{
This function replaces all elements of an integer matrix, which are under a 
certain threshold (<) with zero.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# replace_threshold(m, 1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{filter_subsets}
\alias{filter_subsets}
\title{Remove all biclusters from a list, that are identical
or perfect subsets from each other.
Additionally all invalid biclusters are 
removed (See \code{\link{validate_bicluster}}).}
\usage{
filter_subsets(bics)
}
\arguments{
\item{bics}{A list of bicluster objects}
}
\value{
A list of bicluster objects, where 
perfects subsets or identical biclusters are deleted.
}
\description{
Remove all biclusters from a list, that are identical
or perfect subsets from each other.
Additionally all invalid biclusters are 
removed (See \code{\link{validate_bicluster}}).
}
\examples{
filter_subsets(list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
    bicluster(row=c(1,2,3,4), column=c(1,2,3,4))))
    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{clean_bicluster_list}
\alias{clean_bicluster_list}
\title{Clean a list of biclusters, by returning only the valid ones,}
\usage{
clean_bicluster_list(bics)
}
\arguments{
\item{bics}{A list of bicluster objects.}
}
\value{
A lis tof bicluster objects
}
\description{
Clean a list of biclusters, by returning only the valid ones,
}
\examples{
b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
        bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
clean_bicluster_list(b)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{randomize_matrix}
\alias{randomize_matrix}
\title{Randomize a matrix}
\usage{
randomize_matrix(m)
}
\arguments{
\item{m}{A matrix.}
}
\value{
A randomized version of the input matrix.
}
\description{
Randomize a matrix bu shuffling all rows and columns.
}
\examples{
m <- matrix(c(1,2,3,4), nrow=2)
randomize_matrix(m)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{full_graph}
\alias{full_graph}
\title{Generate a similarity network for a list of biclusters}
\usage{
full_graph(
  bics,
  m,
  rr_weight = 1L,
  rc_weight = 1L,
  cc_weight = 1L,
  weighting = 0L
)
}
\arguments{
\item{bics}{A list of biclusters.}

\item{m}{The matrix, that was used to calculated the biclusters.}

\item{rr_weight}{Weight row-row interactions.}

\item{rc_weight}{Weight row-col interactions.}

\item{cc_weight}{Weight col-col interactions.}

\item{weighting}{Weight interactions by bicluster size. 0 - no weighting, 
1 - multiply by bicluster size, 2 - divide by bicluster size.}
}
\value{
An adjacency matrix.
}
\description{
The function computes a adjacency 
matrix for rows and columns of biclusters.
The matrix values show, how often two rows or two columns or a row and a 
column occur together in biclusters.
In the resulting adjacency matrix, rows are listed first, followed 
by columns. 
They have the same order as the the rows and columns of the input matrix.
}
\details{
In case the given biclusters have overall more or less columns than rows, 
the interactions can be weighted to visualize the result properly.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
        bicluster(row=c(3,4,5,6), column=c(3,4,5,6)),
        bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
# full_graph(b, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{write_graphml}
\alias{write_graphml}
\title{Save adjacency matrix as GraphML file}
\usage{
write_graphml(m, filename, cols)
}
\arguments{
\item{m}{A symmetric numeric matrix (Adjacency matrix). Rownames 
are considered as node names.}

\item{filename}{Name of the resulting GraphML 
file (should end with ".gml").}

\item{cols}{Node colors.}
}
\value{
0 if successful.
}
\description{
Save and adjacency matrix as returned by \code{\link{full_graph}} or 
1 - \code{\link{distance_matrix}} as a GraphML file.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# write_graphml(apply_threshold(bn), "testfile.txt")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{apply_threshold,cooccurrence_net-method}
\alias{apply_threshold,cooccurrence_net-method}
\title{Apply a threshold to a co-occurrence adjacency matrix.}
\usage{
\S4method{apply_threshold}{cooccurrence_net}(bic_net)
}
\arguments{
\item{bic_net}{An object of class \code{cooccurrence_net}.}
}
\value{
An adjacency matrix with the applied threshold.
}
\description{
All values lower than the threshold will be replaced by a 0.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# fn <- feature_network(bics, m)
# apply_threshold(fn)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster.R
\docType{class}
\name{bicluster_net-class}
\alias{bicluster_net-class}
\alias{bicluster_net}
\title{A S4 class to store bicluster networks.}
\description{
Object that is returned e.g. be the
function \code{\link{bicluster_network}}.
}
\section{Slots}{

\describe{
\item{\code{adjacency_matrix}}{Adjacency matrix of bicluster similarities.}

\item{\code{threshold}}{Estimated threshold for the bicluster similarity adjacency
matrix. All values lower than that in the matrix should be discarded.
(Note that the indicated threshold is not applied
to the \code{adjacency_matrix})}

\item{\code{algorithms}}{List of algorithms that contributed to this bicluster
network.}
}}

\examples{
bicluster_net(adjacency_matrix=matrix(seq(1:16), nrow=4),
    threshold=4)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{getallBFClusters}
\alias{getallBFClusters}
\title{Get all biclusters from a Bi-Force output file.}
\usage{
getallBFClusters(filename)
}
\arguments{
\item{filename}{Name of the Bi-Force output file.}
}
\value{
List of biclusters in the form of \code{\link{getBFCluster}}
}
\description{
Get all biclusters from a Bi-Force output file.
}
\examples{
a <- "PathToBiForceOutput.txt"
# getallBFClusters(a)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{replace_values_float}
\alias{replace_values_float}
\title{Replace values in a adjacency matrix.}
\usage{
replace_values_float(mat, threshold, replace_higher = TRUE)
}
\arguments{
\item{mat}{A numeric matrix}

\item{threshold}{All values in the matrix lower than this values are 
replaced by 0.}

\item{replace_higher}{If set to true, all values >= \code{threshold} 
are replaced by 1.}
}
\value{
A numeric matrix with (partially) replaced values.
}
\description{
Same as \code{\link{replace_values}}, but for (positive) non-integer
matrices.
}
\details{
Replace values in a numeric matrix, that are lower than a certain 
threshold.
}
\examples{
replace_values(matrix(rnorm(100), nrow=10), threshold=1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{zero_subsetting}
\alias{zero_subsetting}
\title{Make a vector of R indices compatible with c++ by 
substracting every element by one.}
\usage{
zero_subsetting(v)
}
\arguments{
\item{v}{A numeric vector.}
}
\value{
A numeric vector with every element decremented by one.
}
\description{
Make a vector of R indices compatible with c++ by 
substracting every element by one.
}
\examples{
zero_subsetting(c(1,2,3,4,5))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{bicluster_net_to_igraph}
\alias{bicluster_net_to_igraph}
\title{Convert Bicluster network to an igraph graph object}
\usage{
bicluster_net_to_igraph(bic_net)
}
\arguments{
\item{bic_net}{An object of class \code{bicluster_net}.}
}
\value{
An \code{igraph::\link[igraph]{graph}} object.
}
\description{
The function converts a \code{\link{bicluster_net}} object into an igraph
graph object.
The \code{threshold} is used as a cutoff for the edges of the network.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# bicluster_net_to_igraph(bn)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{select_biclusters_from_bicluster_network,bicluster_net,list-method}
\alias{select_biclusters_from_bicluster_network,bicluster_net,list-method}
\title{Create a subset of biclusters based on a bicluster network}
\usage{
\S4method{select_biclusters_from_bicluster_network}{bicluster_net,list}(bic_net, bics)
}
\arguments{
\item{bic_net}{A \code{\link{bicluster_net}}.}

\item{bics}{A list of \code{\link{bicluster}} objects as returned
by \code{\link{get_biclusters}}.}
}
\value{
A subsetted list of \code{\link{bicluster}} objects.
}
\description{
The function returns an adapted bicluster list based on
a \code{\link{bicluster_net}} object.
This might be necessary e.g. after \code{\link{get_louvain_communities}}
was used and a community consists only of a subset of the biclusters.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# lc <- get_louvain_communities(bn)
# select_biclusters_from_bicluster_network(lc[[1]], bics)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{p_overlap}
\alias{p_overlap}
\title{Probability for an overlap of two samples.}
\usage{
p_overlap(x, y, k, n)
}
\arguments{
\item{x}{Overlap.}

\item{y}{Size of sample 1.}

\item{k}{Size of Sample 2.}

\item{n}{Number of all elements sampled from.}
}
\value{
Overlap probability.
}
\description{
The probability is computed using the 
forumla \eqn{\frac{{y \choose x}\times {n-y \choose k-x}}{{n \choose k}}}.
}
\examples{
p_overlap(10, 20, 30, 100)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_fabia.R
\name{getFabiaClusters}
\alias{getFabiaClusters}
\title{Extract a list of bicluster objects from an fabia biclustering object.}
\usage{
getFabiaClusters(bics, mat, transposed = FALSE, filterfun = NULL, ...)
}
\arguments{
\item{bics}{Extracted fabia biclusters.}

\item{mat}{Original matrix, that was used for biclustering.}

\item{transposed}{\code{True}, if the bicluster calculation was performed
on a tranposed matrix.}

\item{filterfun}{A function to filter biclusters. Only if the function
returns \code{True}, the bicluster is added to the returned list.
The function has to accept a the bicluster (given as submatrix
of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.}

\item{...}{Other parameters forwarded to the \code{filterfun}.}
}
\value{
A list of \code{\link{bicluster}} objects, which have to
be valid (See \code{\link{validate_bicluster}}.
}
\description{
Extract a list of bicluster objects from an fabia biclustering object.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# res <- fabia::extractBic(fabia::fabia(m, p=5))
# getFabiaClusters(res, m)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{get_algorithms}
\alias{get_algorithms}
\title{Get Algorithms}
\usage{
get_algorithms(bics)
}
\arguments{
\item{bics}{a list of \code{\link{bicluster}} objects.}
}
\value{
A character vector with algorithm names
}
\description{
Get a unique vector of algorithms from a
list of \code{\link{bicluster}} objects.
}
\examples{
b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4), algorithm="isa"),
    bicluster(row=c(3,4,5,6), column=c(3,4,5,6), algorithm="QUBIC"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{get_bic_net_algorithms,bicluster_net-method}
\alias{get_bic_net_algorithms,bicluster_net-method}
\title{Get bicluster network algorithms}
\usage{
\S4method{get_bic_net_algorithms}{bicluster_net}(bic_net)
}
\arguments{
\item{bic_net}{An object of class \code{bicluster_net}.}
}
\value{
Algorithm names as characters.
}
\description{
Return algorithms from bicluster network
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# get_bic_net_algorithms(bn)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_biclust.R
\name{getBiclustClusters}
\alias{getBiclustClusters}
\title{Extract a list of bicluster objects from a biclust object.}
\usage{
getBiclustClusters(
  bics,
  mat,
  method = "biclust",
  transposed = FALSE,
  filterfun = NULL,
  ...
)
}
\arguments{
\item{bics}{A biclust object.}

\item{mat}{Original matrix, that was used for biclustering.}

\item{method}{Name of the used biclustering algorithm. Should be one of
the following: "biclust", "biclust-bimax", "biclust-cc", "biclust-plaid",
"biclust-quest", "biclust-spectral", "biclust-xmotifs" or "biclust-qubic",
"biclust-unibic".}

\item{transposed}{\code{True}, if the bicluster calculation was
performed on a tranposed matrix.}

\item{filterfun}{A function to filter biclusters. Only if the function
returns \code{True}, the bicluster is added to the returned list.
The function has to accept a the bicluster (given as submatrix
of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.}

\item{...}{Other parameters forwarded to the \code{filterfun}.}
}
\value{
A list of \code{\link{bicluster}} objects, which have
to be valid (See \code{\link{validate_bicluster}}.
}
\description{
Extract a list of bicluster objects from a biclust object.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# res <- biclust::biclust(m, method = biclust::BCBimax())
# getBiclustClusters(res, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{NoBFBiclusters}
\alias{NoBFBiclusters}
\title{Get the number of biclusters, generated by the Bi-Force algorithm.}
\usage{
NoBFBiclusters(filename)
}
\arguments{
\item{filename}{Name of the Bi-Force output file.}
}
\value{
Number of biclusters.
}
\description{
Get the number of biclusters, generated by the Bi-Force algorithm.
}
\examples{
a <- "PathToBiForceOutput.txt"
# NoBFBiclusters(a)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{p_overlap_higher}
\alias{p_overlap_higher}
\title{Probability for an overlap higher or equal to the observed 
one of two samples}
\usage{
p_overlap_higher(x, y, k, n)
}
\arguments{
\item{x}{Overlap.}

\item{y}{Size of sample 1.}

\item{k}{Size of Sample 2.}

\item{n}{Number of all elements sampled from.}
}
\value{
Overlap probability.
}
\description{
Is computed by adding up probabilities for all possible 
overlaps equal or higher to the observed one using the 
function \code{\link{p_overlap}}.
}
\examples{
p_overlap_higher(10, 20, 30, 100)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{node_size}
\alias{node_size}
\title{Node sizes for plotting bicluster networks.}
\usage{
node_size(bics, base_size = 10, offset = 0.2, MARGIN = "column")
}
\arguments{
\item{bics}{A list of \code{\link{bicluster}} objects.}

\item{base_size}{Is multiplied with the atan result for the node size}

\item{offset}{Offset for the atan calculation. Has to be > 0.
Smaller values result in higher differences of node sizes.}

\item{MARGIN}{"column", "row" or "both" are taken into account
for the size of a bicluster bicluster}
}
\value{
Vector of node sizes as floats.
}
\description{
When plotting bicluster networks, node sizes adapted to bicluster sizes
can improve visual inspection.
Node sizes are computed using the following formula:
\code{(atan( (x - min(x)) / (max(x) - min(x)) + offset ) * base_size)}.
With x being defined a vector of bicluster sizes defined
by the \code{MARGIN} parameter.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# nz <- node_size(bics)
# plot_algo_network(bn, bics, vertex.size=nz)
# plot(bn, vertex.size=node_size(bics, offset=.1, base_size=15))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{set_bicluster_names}
\alias{set_bicluster_names}
\title{Add row-/colnames to a bicluster object.}
\usage{
set_bicluster_names(bic, m)
}
\arguments{
\item{bic}{A bicluster object.}

\item{m}{The matrix, that was used for the
biclustering. (Works only if matrix has row-/colnames.)}
}
\value{
The updated bicluster object.
}
\description{
Add row-/colnames to a bicluster object.
}
\examples{
m <- matrix(c(1,2,3,4), nrow=2)
rownames(m) <- c("r1", "r2")
rownames(m) <- c("c1", "c2")
set_bicluster_names(bicluster(row=c(1,2), column=c(1,2)), m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{bicluster_to_matrix}
\alias{bicluster_to_matrix}
\title{Convert a bicluster object to an acutal submatrix of the original matrix.}
\usage{
bicluster_to_matrix(m, bic)
}
\arguments{
\item{m}{Matrix on which the bicluster was computed}

\item{bic}{Bicluster object}
}
\value{
A matrix.
}
\description{
Convert a bicluster object to an acutal submatrix of the original matrix.
}
\examples{
bicluster_to_matrix(matrix(seq(1:16), nrow=4), 
    bicluster(row=c(1,2), column=c(1,2)))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster.R
\docType{class}
\name{cooccurrence_net-class}
\alias{cooccurrence_net-class}
\alias{cooccurrence_net}
\title{A S4 class to store co-occurence networks.}
\description{
Object that is returned e.g. be the function \code{\link{feature_network}}.
}
\section{Slots}{

\describe{
\item{\code{adjacency_matrix}}{Adjacency matrix of row- and column-element
co-occurences.}

\item{\code{threshold}}{Estimated threshold for the co-occurence adjacency matrix.
All values lower than that in the matrix should be
discarded. (Note that the indicated threshold is not
applied to the \code{adjacency_matrix})}
}}

\examples{
cooccurrence_net(adjacency_matrix=matrix(seq(1:16), nrow=4),
    threshold=4)
    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_biclusters.R
\name{get_biclusters}
\alias{get_biclusters}
\title{Extract biclusters from different algorithms/packages}
\usage{
get_biclusters(bics, mat, method, transposed = FALSE, filterfun = NULL, ...)
}
\arguments{
\item{bics}{A resulting object from a biclustering
algorithm (extracted biclusters for fabia) or filename for stored
biclustering results.}

\item{mat}{Original matrix, that was used for biclustering.}

\item{method}{Used biclustering package. One of "biclust"
(can be further specified as "biclust-bimax",
"biclust-cc", "biclust-plaid", "biclust-quest",
"biclust-qubic",
"biclust-spectral", "biclust-xmotifs", "biclust-unibic"),
"BicARE", "isa", "fabia", "biforce", "biclustpy", "qubic2"
or "akmbiclust".}

\item{transposed}{Indicate, whether a transposed version of the matrix is
used for biclustering. The \code{matrix} should not be transposed,
when this argument is set to \code{True}.}

\item{filterfun}{A function to filter biclusters.
Only if the function returns \code{True}, the bicluster is added to
the returned list. The function has to accept a bicluster
(given as submatrix of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.}

\item{...}{Other parameters forwarded to the \code{filterfun}.}
}
\value{
A list of \code{\link{bicluster}} objects, which are
valid (See \code{\link{validate_bicluster}}).
}
\description{
Converts biclusters output of different algorithms/packages in to lists
of \link{bicluster} objects. Many algoritms can be directly executed using
the \code{run_...} methods from this package.
This directly returns the converted results. Not all algorithms are shipped
with this package, like Bi-Force, which is running in Java as a standalone
tool or BicARE,
which required an full import using \code{library(BicARE)} in order to run.
But their results can be converted using this function.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# res <- isa2::isa(m)
# get_biclusters(res, m, "isa")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster.R
\docType{class}
\name{bicluster-class}
\alias{bicluster-class}
\alias{bicluster}
\title{A S4 class to store biclusters.}
\description{
A S4 class to store biclusters.
}
\section{Slots}{

\describe{
\item{\code{row}}{A vector of row.}

\item{\code{column}}{A vector of columns.}

\item{\code{rowname}}{A vector of names for the rows in \code{row}.}

\item{\code{colname}}{A vector of names for the columns in \code{column}.}

\item{\code{algorithm}}{Algorithm that predicted this bicluster.}
}}

\examples{
bicluster(row=c(1,2), column=c(1,2), 
    rowname=c("a", "b"), colname=c("e", "f"))
    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{occurance_matrix}
\alias{occurance_matrix}
\title{Occurance matrix of data points in a list of biclusters}
\usage{
occurance_matrix(bics, mat)
}
\arguments{
\item{bics}{A list of \code{\link{bicluster}} objects.}

\item{mat}{The data matrix used for biclustering.}
}
\value{
A numeric matrix with the dimensions of the input matrix. 
The values represent the frequency of occurance of this point in 
the list of biclusters.
}
\description{
The function computes a matrix with the same dimensions as the input 
matrix and fills the matrix elements with the frequence of occurance 
of the data points in the input list of biclusters.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# occurance_matrix(bics, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter_biclusters.R
\name{filter_biclusters}
\alias{filter_biclusters}
\title{Filter biclusters based on a user defined filter function.}
\usage{
filter_biclusters(bics, mat, filterfun, ...)
}
\arguments{
\item{bics}{A list of valid bicluster objects.}

\item{mat}{Original matrix, that was used for biclustering.}

\item{filterfun}{A function to filter biclusters. Only if the function
returns \code{True}, the bicluster is added to the returned list.
The function has to accept a the bicluster (given as submatrix
of \code{mat}) \code{filterfun(bicluster_matrix, ...)}.}

\item{...}{Other parameters forwarded to the \code{filterfun}.}
}
\value{
A filtered list ob bicluster objects with
length(returned_list)<=length(bics).
}
\description{
If the function returns \code{True}, the bicluster is added to the output
list of biclusters.
Every bicluster is validated, before forwarding to the filter-function.
}
\examples{
# m <- matrix(runif(100), nrow=10)
b <- list(bicluster(row=c(3,4), column=c(3,4)),
    bicluster(row=c(3,4,5,6), column=c(3,4,5,6)),
    bicluster(row=c(3,4,5,6), column=c(3,6)))
# filter_biclusters(b, m, function(x) sum(x) < 0)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pipeline.R
\name{feature_network}
\alias{feature_network}
\title{Generate a co-occurence network}
\usage{
feature_network(
  bics,
  mat,
  n_randomizations = 5,
  n_steps = 100,
  plot_edge_dist = TRUE,
  sn_ratio = 1,
  error_threshold = 0.05,
  return_plot_data = FALSE,
  rr = 1,
  rc = 1,
  cc = 1,
  w = 0
)
}
\arguments{
\item{bics}{A list of bicluster objects.}

\item{mat}{The matrix used for biclustering.}

\item{n_randomizations}{The number of randomizations for cut-off
estimation. (The mean of all randomizations is used).}

\item{n_steps}{Number of points where the difference between
randomizations and the real data is evaluated.}

\item{plot_edge_dist}{Show the plots for threshold estimation.}

\item{sn_ratio}{If \code{TRUE}, the signal to noise ratio is
computed, otherwise the \code{error_threshold} is used to to
estimate the threshold at which only \code{error_threshold*100} percent
of the edges are estimated to be random overlaps.}

\item{error_threshold}{If \code{sn_ratio==FALSE} this cut-off is
used to estimate the cut-off at which only \code{error_threshold*100}
percent of the edges are estimated to be random overlaps.}

\item{return_plot_data}{Please do not use outside of the package.}

\item{rr}{See \code{\link{full_graph}}.}

\item{rc}{See \code{\link{full_graph}}.}

\item{cc}{See \code{\link{full_graph}}.}

\item{w}{See parameter weighting of \code{\link{full_graph}}.}
}
\value{
An object of class \code{\link{cooccurrence_net}}.
}
\description{
The function computes a co-occurence network, based on the
function \code{\link{full_graph}}.
A similarity threshold is calculated using randomized
biclusters (the bicluster size distribution is kept).
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# feature_network(bics, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{filter_bicluster_size}
\alias{filter_bicluster_size}
\title{Filter a list of bicluster objects, by erasing all biclusters, 
that do not fulfill the minimum number of rows and columns.
Utilizes the function \code{\link{validate_bicluster}}.}
\usage{
filter_bicluster_size(bics, minRow, minCol)
}
\arguments{
\item{bics}{List of bicluster objects.}

\item{minRow}{Minimum number of rows.}

\item{minCol}{Minimum number of columns.}
}
\value{
A filtered list of bicluster objects.
}
\description{
Filter a list of bicluster objects, by erasing all biclusters, 
that do not fulfill the minimum number of rows and columns.
Utilizes the function \code{\link{validate_bicluster}}.
}
\examples{
b <- list(bicluster(row=c(1,2), column=c(1,2,3,4)),
        bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
filter_bicluster_size(b, 3, 3)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{sample_biclusters}
\alias{sample_biclusters}
\title{Sample a list of biclusters.}
\usage{
sample_biclusters(bics, mat)
}
\arguments{
\item{bics}{A list of validated bicluster objects.}

\item{mat}{The numeric matrix, that was used to generate the biclusters.}
}
\value{
A list of \link{bicluster} objects.
}
\description{
The function generates a list of biclusters given an input list of 
biclusters, where each bicluster has the same number or rows and columns, 
but with sampled entries from a uniform distribution of all rows and 
columns is the matrix.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# sample_biclusters(bics, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_algorithms.R
\name{run_unibic}
\alias{run_unibic}
\title{Run the UniBic biclustering algorithm}
\usage{
run_unibic(data_matrix, minRow = 2, minCol = 2, ...)
}
\arguments{
\item{data_matrix}{A numeric matrix.}

\item{minRow}{Same parameters as in \link{filter_bicluster_size}.}

\item{minCol}{Same parameters as in \link{filter_bicluster_size}.}

\item{...}{Other parameters forwarded to the runibic::BCUnibic function.
function.}
}
\value{
a list of \link{bicluster} objects.

Function as a string, which can be executed.
}
\description{
The function executes the runibic::BCUnibic biclustering algorithm,
returning a list of biclusters converted into bicluster objects
compatible with this package.
If the algorithm fails to run, an empty list is returned.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# run_unibic(m, nbic=10)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{getQUBIC2biclusters}
\alias{getQUBIC2biclusters}
\title{Extract QUBIC2 biclusters}
\usage{
getQUBIC2biclusters(filename, transposed = FALSE)
}
\arguments{
\item{filename}{Path to the QUBIC2 results file.}

\item{transposed}{Set to TRUE, if the
biclustering was performed on a tranposed matrix.}
}
\value{
A list of validated bicluster 
objects (See \code{\link{validate_bicluster}}).
}
\description{
Extract biclusters from a QUBIC2 "*.blocks" file. 
Row and column names are not added to the bicluster objects.
}
\examples{
a <- "PathToQUBIC2output.txt"
# Not run: getQUBIC2biclusters(a)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{bicluster_heatmap,bicluster,matrix-method}
\alias{bicluster_heatmap,bicluster,matrix-method}
\title{Plot a heatmap of a bicluster}
\usage{
\S4method{bicluster_heatmap}{bicluster,matrix}(bic, m, ...)
}
\arguments{
\item{bic}{A bicluster object.}

\item{m}{The matrix, that was used for the
biclustering. (Works only if matrix has row-/colnames.)}

\item{...}{Arguments forwarded to \code{stats::\link[stats]{heatmap}}.}
}
\value{
A plot object
}
\description{
Uses the \code{stats::\link[stats]{heatmap}} function.
}
\examples{
m <- matrix(c(1,2,3,4), nrow=2)
rownames(m) <- c("r1", "r2")
rownames(m) <- c("c1", "c2")
bicluster_heatmap(bicluster(row=c(1,2), column=c(1,2)), m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{get_louvain_communities,bicluster_net-method}
\alias{get_louvain_communities,bicluster_net-method}
\title{Get louvain communities from a bicluster network}
\usage{
\S4method{get_louvain_communities}{bicluster_net}(bic_net, min_size = 2, bics = NULL)
}
\arguments{
\item{bic_net}{A \code{\link{bicluster_net}} object.}

\item{min_size}{Minimum size of a louvain community to
be returned.}

\item{bics}{Optional. The respective list of biclusters to identify,
from which algorithms a community originates.}
}
\value{
A list of \code{\link{bicluster_net}} objects.
}
\description{
Extracts the louvain communities from a \code{\link{bicluster_net}}
object using the louvain modularity optimization from the \code{igraph}
package (\code{\link[igraph]{cluster_louvain}}).
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# get_louvain_communities(bn)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{occurance_table}
\alias{occurance_table}
\title{Occurance table of data points in a list of biclusters}
\usage{
occurance_table(bics, mat, threshold = 0)
}
\arguments{
\item{bics}{A list of \code{\link{bicluster}} objects.}

\item{mat}{The data matrix used for biclustering.}

\item{threshold}{Only data points higher than this threshold are returned.}
}
\value{
A DataFrame with the frequencies of occurance for values higher 
than a \code{threshold}.
}
\description{
The function uses the \code{\link{occurance_matrix}} function and 
returns all values higher than the \code{threshold} as a DataFrame.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# occurance_table(bics, m, threshold=.1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bicluster_net_methods.R
\name{plot_algo_network}
\alias{plot_algo_network}
\title{Plot a bicluster network colored by algorithms.}
\usage{
plot_algo_network(bic_net, bics, new_layout = TRUE, ...)
}
\arguments{
\item{bic_net}{A \code{\link{bicluster_net}} object.}

\item{bics}{The corresponding list of biclusters from \code{bic_net}.}

\item{new_layout}{If \code{FALSE}, the plot accepts a network layout as
a parameter, other wise a new layout is computed.}

\item{...}{Plot parameters forwarded
to \code{igraph::\link[igraph]{plot.igraph}}
After calculating communities with \code{\link{get_louvain_communities}}
it is necessary to get the subset of biclusters
using \code{\link{select_biclusters_from_bicluster_network}}.}
}
\value{
If \code{new_layout}, a new network layout is returned
that can be used for other plots.
}
\description{
In the plot each bicluster is colored by the algorithm, that generated it.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# plot_algo_network(bn, bics)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{transpose_bicluster}
\alias{transpose_bicluster}
\title{Transpose a bicluster.
Row and column slots will be changed.}
\usage{
transpose_bicluster(bic)
}
\arguments{
\item{bic}{A bicluster object.}
}
\value{
A transposed bicluster object,
}
\description{
Transpose a bicluster.
Row and column slots will be changed.
}
\examples{
transpose_bicluster(bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{write_matrix}
\alias{write_matrix}
\title{Write an R matrix to a file (In a Bi-Force or QUBIC2 readable format).}
\usage{
write_matrix(m, filename, qubic2_format = FALSE)
}
\arguments{
\item{m}{A Numeric matrix.}

\item{filename}{Name of the output file.}

\item{qubic2_format}{Write the matrix in a format QUBIC2 is able to read. 
This means adding a row- and column names to the file.}
}
\value{
0 if file was written successfully.
}
\description{
Write an R matrix to a file (In a Bi-Force or QUBIC2 readable format).
}
\examples{
write_matrix(matrix(c(1,2,3,4), nrow=2), "testfile.txt")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{dim,bicluster-method}
\alias{dim,bicluster-method}
\title{Get the dimensions of a bicluster.}
\usage{
\S4method{dim}{bicluster}(x)
}
\arguments{
\item{x}{A bicluster object.}
}
\value{
A numeric vector with the lengths of the rows and
columns of the bicluster.
}
\description{
Get the dimensions of a bicluster.
}
\examples{
dim(bicluster(row=c(1,2), column=c(1,2)))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pipeline.R
\name{filter_matrix}
\alias{filter_matrix}
\title{Filter a matrix}
\usage{
filter_matrix(mat, threshold = 1)
}
\arguments{
\item{mat}{A Numeric matrix.}

\item{threshold}{All values below will be replaces by 0.}
}
\value{
A filtered numeric matrix.
}
\description{
All values below the threshold will be replaces by 0.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# filter_matrix(m, threshold=1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{detect_elements}
\alias{detect_elements}
\title{Detect the number of elements in a list of biclusters.}
\usage{
detect_elements(bics, MARGIN = "row")
}
\arguments{
\item{bics}{A list of bicluster objects.}

\item{MARGIN}{Choose if the distance is computed over \code{"row"} 
or \code{"column"}.}
}
\value{
Return highest row or column index from a list of biclusters.
}
\description{
Finds the highest element in a list of bicluster objects.
}
\examples{
b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
        bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
detect_elements(b)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{distance_matrix}
\alias{distance_matrix}
\title{Compute distances between biclusters}
\usage{
distance_matrix(bics, MARGIN = "row", metric = 1L)
}
\arguments{
\item{bics}{A list of bicluster objects.}

\item{MARGIN}{Choose if the distance is computed over \code{"row"} 
or \code{"column"}.}

\item{metric}{Integer indicating which metric is used. 1: Bray-Curtis 
dissimilarity (default), 2: Jaccard distance, 3: 1-overlap coefficient  
4: 1 - Fowlkes–Mallows index.}
}
\value{
A numeric matrix of the dissimilarities between all 
given biclusters.
}
\description{
This function computes a distance matrix between biclusters using 
different dissimilarity metrics.
}
\examples{
b <- list(bicluster(row=c(1,2,3,4), column=c(1,2,3,4)),
        bicluster(row=c(3,4,5,6), column=c(3,4,5,6)))
distance_matrix(b)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{network_edge_strength_float}
\alias{network_edge_strength_float}
\title{Count edges in an adjacency matrix using different cut-off 
thresholds.}
\usage{
network_edge_strength_float(adjm, steps = 100L, maximum = 0)
}
\arguments{
\item{adjm}{A symmetrix numeric matrix.}

\item{steps}{Number of steps for which the edge count is evaluated.}

\item{maximum}{Highest value until which the edge weight is evaluated. 
If maximum=0, the max value of \code{adjm} is used.}
}
\value{
A numeirc matrix of \code{dim(max(adjm), 2)}. 
The first column indicated the applied threshold, the second 
column the remaining edges.
}
\description{
Same as \code{\link{network_edge_strength}}, but for (positive) 
non-integer matrices.
}
\details{
Computes the how many edges remain in a network if edges with a 
weight lower than a certain threshold are removed.
The number of remaining edges between 1 and max(adjm) are calculated.
It is assumend that the matrix is symmetric and therefore 
the number of edges divided by two.
Uses the function \code{\link{replace_values_float}}.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bn <- bicluster_network(bics, m)
# network_edge_strength_float(apply_threshold(bn))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{p_overlap_2d}
\alias{p_overlap_2d}
\title{Probability for an overlap of two dimensional samples}
\usage{
p_overlap_2d(ov_x, ov_y, s1x, s1y, s2x, s2y, mat_x, mat_y)
}
\arguments{
\item{ov_x}{Overlap in the first dimension.}

\item{ov_y}{Overlap in the second dimension.}

\item{s1x}{First sample of the first dimension.}

\item{s1y}{First sample of the second dimension.}

\item{s2x}{Second sample of first dimension.}

\item{s2y}{Second sample of the second dimension.}

\item{mat_x}{Number of all elements from the first 
dimension sampled from.}

\item{mat_y}{Number of all elements from the second 
dimension sampled from.}
}
\value{
Overlap probability.
}
\description{
Is computed by calculating the overlap probability for each 
dimension independently and multiplying them using the 
function \code{\link{p_overlap}}.
}
\examples{
p_overlap_2d(10, 10, 20, 20, 30, 30, 100, 100)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{replace_values}
\alias{replace_values}
\title{Replace values in an integer adjacency matrix.}
\usage{
replace_values(mat, threshold, replace_higher = TRUE)
}
\arguments{
\item{mat}{An integer matrix}

\item{threshold}{All values in the matrix lower than this values are 
replaced by 0.}

\item{replace_higher}{If set to true, all values >= \code{threshold} 
are replaced by 1.}
}
\value{
An integer matrix with (partially) replaced values.
}
\description{
Replace values in an integer matrix, that are lower than a certain 
threshold.
}
\examples{
replace_values(matrix(seq(1, 16), nrow=4), threshold=4)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{network_edge_strength}
\alias{network_edge_strength}
\title{Count edges in an adjacency matrix using different cut-off thresholds.}
\usage{
network_edge_strength(adjm)
}
\arguments{
\item{adjm}{A symmetrix numeric matrix.}
}
\value{
A numeirc matrix of \code{dim(max(adjm), 2)}. The first column 
indicated the applied threshold, the second column the remaining edges.
}
\description{
Computes the how many edges remain in a network if edges with a weight 
lower than a certain threshold are removed.
The number of remaining edges between 1 and max(adjm) are calculated.
It is assumend that the matrix is symmetric and therefore the number 
of edges divided by two.
Uses the function \code{\link{replace_values}}.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# fn <- feature_network(bics, m)
# network_edge_strength(apply_threshold(fn))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pipeline.R
\name{bicluster_network}
\alias{bicluster_network}
\title{Generate a bicluster network}
\usage{
bicluster_network(
  bics,
  mat,
  n_randomizations = 5,
  MARGIN = "both",
  metric = 4,
  n_steps = 100,
  plot_edge_dist = TRUE,
  sn_ratio = TRUE,
  error_threshold = 0.05,
  return_plot_data = FALSE,
  prob_scale = FALSE,
  prl = FALSE
)
}
\arguments{
\item{bics}{A list of bicluster objects.}

\item{mat}{The matrix used for biclustering.}

\item{n_randomizations}{The number of randomizations for
cut-off estimation. (The mean of all randomizations is used).}

\item{MARGIN}{Margin over which the similarity is computed.
Can be "row", "column", "mean" (In this case the mean of
row and column similarity is used) or "both" (In this case
the similarity between all the datapoints of biclusters is used).}

\item{metric}{The similarity metric same as
in \code{\link{similarity_matrix}}.}

\item{n_steps}{Number of points where the difference
between randomizations and the real data is evaluated.}

\item{plot_edge_dist}{Show the plots for cut-off estimation
with the error model.}

\item{sn_ratio}{If \code{TRUE}, the signal to noise ratio is
computed, otherwise the \code{error_threshold} is used to to
estimate the cut-off at which only \code{error_threshold*100}
percent of the edges are estimated to be random overlaps.}

\item{error_threshold}{If \code{sn_ratio==FALSE} this threshold
is used to estimate the threshold at which
only \code{error_threshold*100} percent of the edges are
estimated to be random overlaps.}

\item{return_plot_data}{Please do not use outside of the package.}

\item{prob_scale}{Scale similarity by the probability of an
overlap equal of higher to the observed one. The scaling is
done by multiplying the similarity
with \code{(1 - (1 / (1 - log(overlap_probability, base=100))))}.
The probability is computed using the f
unction \code{\link{p_overlap_2d_higher}}
for \code{MARGIN =="both"} and  \code{\link{p_overlap_higher}}
otherwise. Can be helpful for big imbalances of bicluster sizes.}

\item{prl}{Compute the similarity matrix using multiple
cores (works only for \code{MARGIN="both"}). The number of core can be
defined by executing: \code{RcppParallel::setThreadOptions(numThreads = 4)}
before running this function.}
}
\value{
An object of class \code{\link{bicluster_net}}.
}
\description{
The function computes a bicluster network based on a selected
similarity metric.
A similarity cut-off is calculated using randomized
biclusters (the bicluster size distribution is kept).
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# bicluster_network(bics, m)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{colhistogram}
\alias{colhistogram}
\title{Get the columnlengths for a list of bicluster objects.}
\usage{
colhistogram(bic)
}
\arguments{
\item{bic}{A list  of bicluster objects.}
}
\value{
A vector with the lenghts of the columns in every bicluster object.
}
\description{
Can be used for e.g. histograms.
}
\examples{
m <- matrix(seq(1:16), nrow=4)
# m <- matrix(rnorm(10000), nrow=100)
# bics <- c(run_fabia(m), run_isa(m), run_plaid(m))
# colhistogram(bics)

}
